using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_BZBGEAR_HDMI_MATRIX_SWITCHER_AND_VIDEOWALL_CONTROLLER
{
    public class UserModuleClass_BZBGEAR_HDMI_MATRIX_SWITCHER_AND_VIDEOWALL_CONTROLLER : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        Crestron.Logos.SplusObjects.StringInput RX_BUFFER;
        Crestron.Logos.SplusObjects.DigitalInput GETSYSTEMSTATUS;
        Crestron.Logos.SplusObjects.DigitalInput GETINXFORMATSTATUS;
        Crestron.Logos.SplusObjects.DigitalInput GETOUTXTYPESTATUS;
        Crestron.Logos.SplusObjects.DigitalInput GETOUTXFORMATSTATUS;
        Crestron.Logos.SplusObjects.DigitalInput CANCELTVWALL;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN1X1;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN1X2;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN1X3;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN1X4;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN2X1;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN3X1;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN4X1;
        Crestron.Logos.SplusObjects.DigitalInput SETMARGIN2X2;
        Crestron.Logos.SplusObjects.DigitalInput AUDIOONLYOPEN;
        Crestron.Logos.SplusObjects.DigitalInput AUDIOONLYCLOSE;
        Crestron.Logos.SplusObjects.DigitalInput AUDIOMODEMANUAL;
        Crestron.Logos.SplusObjects.DigitalInput AUDIOMODEAUTO;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> SETINXAUDIOEMBEDDED;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> SETINXAUDIOLR;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> PRESET_RECALL;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> PRESET_SAVE;
        Crestron.Logos.SplusObjects.AnalogInput SETTVWALL;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> SETVIDEOROUTING;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> SETAUDIOROUTING;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> SETOUTTYPE;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> SETOUTPUTFORMAT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTXMARGINLEFT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTXMARGINRIGHT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTXMARGINTOP;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTXMARGINBOTTOM;
        Crestron.Logos.SplusObjects.StringOutput TX_BUFFER;
        Crestron.Logos.SplusObjects.DigitalOutput FB_AUDIOONLYOPEN;
        Crestron.Logos.SplusObjects.DigitalOutput FB_AUDIOONLYCLOSE;
        Crestron.Logos.SplusObjects.DigitalOutput FB_AUDIOMODEMANUAL;
        Crestron.Logos.SplusObjects.DigitalOutput FB_AUDIOMODEAUTO;
        InOutArray<Crestron.Logos.SplusObjects.DigitalOutput> FB_SETINXAUDIOEMBEDDED;
        InOutArray<Crestron.Logos.SplusObjects.DigitalOutput> FB_SETINXAUDIOLR;
        InOutArray<Crestron.Logos.SplusObjects.DigitalOutput> FB_PRESET;
        Crestron.Logos.SplusObjects.AnalogOutput FB_SETTVWALL;
        InOutArray<Crestron.Logos.SplusObjects.StringOutput> FB_INXFORMAT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_OUTXFORMAT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_OUTXTYPE;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_SETVIDEOROUTING;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_SETAUDIOROUTING;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_OUTXMARGINLEFT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_OUTXMARGINRIGHT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_OUTXMARGINTOP;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> FB_OUTXMARGINBOTTOM;
        UShortParameter DEVICE_OUTPUT_NUM;
        UShortParameter DEVICE_INPUT_NUM;
        UShortParameter DEBUGMODE;
        TVWALLPARAMTER G_TWPARAMETER;
        ushort G_TVWALL_ROW = 0;
        ushort G_TVWALL_COLUME = 0;
        ushort AUDIOMODE_FLAG = 0;
        ushort [] AUDIOOUTPORT;
        CrestronString [] G_SIGNALTYPE;
        CrestronString [] G_INSIGNALFORMAT;
        CrestronString [] G_OUTSIGNALFORMAT;
        private void GETMYSYSTEMSTATE (  SplusExecutionContext __context__ ) 
            { 
            ushort INDEX = 0;
            
            
            __context__.SourceCodeLine = 219;
            TX_BUFFER  .UpdateValue ( "GET SYS AUDIO-SWMODE\r"  ) ; 
            __context__.SourceCodeLine = 220;
            Functions.Delay (  (int) ( 20 ) ) ; 
            __context__.SourceCodeLine = 221;
            TX_BUFFER  .UpdateValue ( "GET SYS AUDIO-ONLY\r"  ) ; 
            __context__.SourceCodeLine = 222;
            Functions.Delay (  (int) ( 20 ) ) ; 
            __context__.SourceCodeLine = 225;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)DEVICE_INPUT_NUM  .Value; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( INDEX  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (INDEX  >= __FN_FORSTART_VAL__1) && (INDEX  <= __FN_FOREND_VAL__1) ) : ( (INDEX  <= __FN_FORSTART_VAL__1) && (INDEX  >= __FN_FOREND_VAL__1) ) ; INDEX  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 227;
                MakeString ( TX_BUFFER , "GET IN{0:d} AUDIO-SRC\r", (short)INDEX) ; 
                __context__.SourceCodeLine = 228;
                Functions.Delay (  (int) ( 20 ) ) ; 
                __context__.SourceCodeLine = 230;
                MakeString ( TX_BUFFER , "GET IN{0:d} IN-SIGNAL\r", (short)INDEX) ; 
                __context__.SourceCodeLine = 231;
                Functions.Delay (  (int) ( 20 ) ) ; 
                __context__.SourceCodeLine = 225;
                } 
            
            __context__.SourceCodeLine = 235;
            ushort __FN_FORSTART_VAL__2 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__2 = (ushort)DEVICE_OUTPUT_NUM  .Value; 
            int __FN_FORSTEP_VAL__2 = (int)1; 
            for ( INDEX  = __FN_FORSTART_VAL__2; (__FN_FORSTEP_VAL__2 > 0)  ? ( (INDEX  >= __FN_FORSTART_VAL__2) && (INDEX  <= __FN_FOREND_VAL__2) ) : ( (INDEX  <= __FN_FORSTART_VAL__2) && (INDEX  >= __FN_FOREND_VAL__2) ) ; INDEX  += (ushort)__FN_FORSTEP_VAL__2) 
                { 
                __context__.SourceCodeLine = 237;
                MakeString ( TX_BUFFER , "GET OUT{0:d} VIDEO\r", (short)INDEX) ; 
                __context__.SourceCodeLine = 238;
                Functions.Delay (  (int) ( 20 ) ) ; 
                __context__.SourceCodeLine = 240;
                MakeString ( TX_BUFFER , "GET OUT{0:d} AUDIO-ROUTE\r", (short)INDEX) ; 
                __context__.SourceCodeLine = 241;
                Functions.Delay (  (int) ( 20 ) ) ; 
                __context__.SourceCodeLine = 243;
                MakeString ( TX_BUFFER , "GET OUT{0:d} OUT-SIGNAL\r", (short)INDEX) ; 
                __context__.SourceCodeLine = 244;
                Functions.Delay (  (int) ( 20 ) ) ; 
                __context__.SourceCodeLine = 246;
                MakeString ( TX_BUFFER , "GET OUT{0:d} OUT-TYPE", (short)INDEX) ; 
                __context__.SourceCodeLine = 247;
                Functions.Delay (  (int) ( 20 ) ) ; 
                __context__.SourceCodeLine = 235;
                } 
            
            
            }
            
        private void SETAVROUTING (  SplusExecutionContext __context__, ushort TYPE , ushort PARAMETER1 , ushort PARAMETER2 ) 
            { 
            CrestronString CMD;
            CMD  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            
            __context__.SourceCodeLine = 264;
            switch ((int)TYPE)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 269;
                    MakeString ( CMD , "SET IN{0:d} VIDEO OUT{1:d}\r", (short)PARAMETER1, (short)PARAMETER2) ; 
                    __context__.SourceCodeLine = 270;
                    TX_BUFFER  .UpdateValue ( CMD  ) ; 
                    __context__.SourceCodeLine = 271;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 276;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (AUDIOMODE_FLAG == 1))  ) ) 
                        { 
                        __context__.SourceCodeLine = 278;
                        MakeString ( CMD , "SET IN{0:d} AUDIO-ROUTE OUT{1:d}\r", (short)PARAMETER2, (short)PARAMETER1) ; 
                        __context__.SourceCodeLine = 279;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        } 
                    
                    else 
                        { 
                        __context__.SourceCodeLine = 283;
                        return ; 
                        } 
                    
                    __context__.SourceCodeLine = 285;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 287;
                    break ; 
                    }
                break;
                
                } 
                
            
            
            }
            
        private void VIDEOROUTINGDISPOSE (  SplusExecutionContext __context__, ushort INPUT_PORT , ushort OUTPUT_PORT ) 
            { 
            
            __context__.SourceCodeLine = 301;
            switch ((int)OUTPUT_PORT)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 303;
                    FB_SETVIDEOROUTING [ 1]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 303;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 304;
                    FB_SETVIDEOROUTING [ 2]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 304;
                    break ; 
                    } 
                
                goto case 3 ;
                case 3 : 
                
                    { 
                    __context__.SourceCodeLine = 305;
                    FB_SETVIDEOROUTING [ 3]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 305;
                    break ; 
                    } 
                
                goto case 4 ;
                case 4 : 
                
                    { 
                    __context__.SourceCodeLine = 306;
                    FB_SETVIDEOROUTING [ 4]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 306;
                    break ; 
                    } 
                
                goto case 5 ;
                case 5 : 
                
                    { 
                    __context__.SourceCodeLine = 307;
                    FB_SETVIDEOROUTING [ 5]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 307;
                    break ; 
                    } 
                
                goto case 6 ;
                case 6 : 
                
                    { 
                    __context__.SourceCodeLine = 308;
                    FB_SETVIDEOROUTING [ 6]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 308;
                    break ; 
                    } 
                
                goto case 7 ;
                case 7 : 
                
                    { 
                    __context__.SourceCodeLine = 309;
                    FB_SETVIDEOROUTING [ 7]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 309;
                    break ; 
                    } 
                
                goto case 8 ;
                case 8 : 
                
                    { 
                    __context__.SourceCodeLine = 310;
                    FB_SETVIDEOROUTING [ 8]  .Value = (ushort) ( INPUT_PORT ) ; 
                    __context__.SourceCodeLine = 310;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 311;
                    break ; 
                    }
                break;
                
                } 
                
            
            
            }
            
        private void SINGALTYPEPOSE (  SplusExecutionContext __context__, ushort DISPOSEMODE , ushort PORT , ushort TPYENUMBER , CrestronString SIGNALTPYE ) 
            { 
            CrestronString CMD;
            CMD  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            ushort SIGNALTPYE_FLAG = 0;
            
            
            __context__.SourceCodeLine = 330;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DISPOSEMODE == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 332;
                switch ((int)TPYENUMBER)
                
                    { 
                    case 1 : 
                    
                        { 
                        __context__.SourceCodeLine = 334;
                        MakeString ( CMD , "SET OUT{0:d} OUT-TYPE UHD-HDMI\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 334;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 334;
                        break ; 
                        } 
                    
                    goto case 2 ;
                    case 2 : 
                    
                        { 
                        __context__.SourceCodeLine = 335;
                        MakeString ( CMD , "SET OUT{0:d} OUT-TYPE UHD-DVI\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 335;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 335;
                        break ; 
                        } 
                    
                    goto case 3 ;
                    case 3 : 
                    
                        { 
                        __context__.SourceCodeLine = 336;
                        MakeString ( CMD , "SET OUT{0:d} OUT-TYPE UHD-HDDMI-1.4\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 336;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 336;
                        break ; 
                        } 
                    
                    goto case 4 ;
                    case 4 : 
                    
                        { 
                        __context__.SourceCodeLine = 337;
                        MakeString ( CMD , "SET OUT{0:d} OUT-TYPE UHD-HDDMI-2.2\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 337;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 337;
                        break ; 
                        } 
                    
                    goto default;
                    default : 
                    
                        {
                        __context__.SourceCodeLine = 338;
                        break ; 
                        }
                    break;
                    
                    } 
                    
                
                } 
            
            else 
                {
                __context__.SourceCodeLine = 341;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DISPOSEMODE == 2))  ) ) 
                    { 
                    __context__.SourceCodeLine = 343;
                    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_SIGNALTYPE[ 0 ] , SIGNALTPYE ))  ) ) 
                        { 
                        __context__.SourceCodeLine = 343;
                        SIGNALTPYE_FLAG = (ushort) ( 0 ) ; 
                        } 
                    
                    else 
                        {
                        __context__.SourceCodeLine = 344;
                        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_SIGNALTYPE[ 1 ] , SIGNALTPYE ))  ) ) 
                            { 
                            __context__.SourceCodeLine = 344;
                            SIGNALTPYE_FLAG = (ushort) ( 1 ) ; 
                            } 
                        
                        else 
                            {
                            __context__.SourceCodeLine = 345;
                            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_SIGNALTYPE[ 2 ] , SIGNALTPYE ))  ) ) 
                                { 
                                __context__.SourceCodeLine = 345;
                                SIGNALTPYE_FLAG = (ushort) ( 2 ) ; 
                                } 
                            
                            else 
                                {
                                __context__.SourceCodeLine = 346;
                                if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_SIGNALTYPE[ 3 ] , SIGNALTPYE ))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 346;
                                    SIGNALTPYE_FLAG = (ushort) ( 3 ) ; 
                                    } 
                                
                                else 
                                    {
                                    __context__.SourceCodeLine = 347;
                                    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_SIGNALTYPE[ 4 ] , SIGNALTPYE ))  ) ) 
                                        { 
                                        __context__.SourceCodeLine = 347;
                                        SIGNALTPYE_FLAG = (ushort) ( 4 ) ; 
                                        } 
                                    
                                    }
                                
                                }
                            
                            }
                        
                        }
                    
                    __context__.SourceCodeLine = 349;
                    switch ((int)PORT)
                    
                        { 
                        case 1 : 
                        
                            { 
                            __context__.SourceCodeLine = 351;
                            FB_OUTXTYPE [ 1]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 351;
                            break ; 
                            } 
                        
                        goto case 2 ;
                        case 2 : 
                        
                            { 
                            __context__.SourceCodeLine = 352;
                            FB_OUTXTYPE [ 2]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 352;
                            break ; 
                            } 
                        
                        goto case 3 ;
                        case 3 : 
                        
                            { 
                            __context__.SourceCodeLine = 353;
                            FB_OUTXTYPE [ 3]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 353;
                            break ; 
                            } 
                        
                        goto case 4 ;
                        case 4 : 
                        
                            { 
                            __context__.SourceCodeLine = 354;
                            FB_OUTXTYPE [ 4]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 354;
                            ; 
                            __context__.SourceCodeLine = 354;
                            break ; 
                            } 
                        
                        goto case 5 ;
                        case 5 : 
                        
                            { 
                            __context__.SourceCodeLine = 355;
                            FB_OUTXTYPE [ 5]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 355;
                            break ; 
                            } 
                        
                        goto case 6 ;
                        case 6 : 
                        
                            { 
                            __context__.SourceCodeLine = 356;
                            FB_OUTXTYPE [ 6]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 356;
                            break ; 
                            } 
                        
                        goto case 7 ;
                        case 7 : 
                        
                            { 
                            __context__.SourceCodeLine = 357;
                            FB_OUTXTYPE [ 7]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 357;
                            break ; 
                            } 
                        
                        goto case 8 ;
                        case 8 : 
                        
                            { 
                            __context__.SourceCodeLine = 358;
                            FB_OUTXTYPE [ 8]  .Value = (ushort) ( SIGNALTPYE_FLAG ) ; 
                            __context__.SourceCodeLine = 358;
                            ; 
                            __context__.SourceCodeLine = 358;
                            break ; 
                            } 
                        
                        goto default;
                        default : 
                        
                            {
                            __context__.SourceCodeLine = 359;
                            break ; 
                            }
                        break;
                        
                        } 
                        
                    
                    } 
                
                }
            
            
            }
            
        private void SINGALFORMATPROCE (  SplusExecutionContext __context__, ushort DISPOSEMODE , ushort PORT , ushort FORMATNUMBER , CrestronString SIGNALFORMAT , ushort SIGNALSOURCE ) 
            { 
            CrestronString CMD;
            CMD  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            ushort SIGNALFORMAT_FLAG = 0;
            
            ushort II = 0;
            
            
            __context__.SourceCodeLine = 380;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DISPOSEMODE == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 382;
                switch ((int)FORMATNUMBER)
                
                    { 
                    case 1 : 
                    
                        { 
                        __context__.SourceCodeLine = 384;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 3840x2160p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 384;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 384;
                        break ; 
                        } 
                    
                    goto case 2 ;
                    case 2 : 
                    
                        { 
                        __context__.SourceCodeLine = 385;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 3840x2160p50\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 385;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 385;
                        break ; 
                        } 
                    
                    goto case 3 ;
                    case 3 : 
                    
                        { 
                        __context__.SourceCodeLine = 386;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 3840x2160p30\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 386;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 386;
                        break ; 
                        } 
                    
                    goto case 4 ;
                    case 4 : 
                    
                        { 
                        __context__.SourceCodeLine = 387;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 3840x2160p25\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 387;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 387;
                        break ; 
                        } 
                    
                    goto case 5 ;
                    case 5 : 
                    
                        { 
                        __context__.SourceCodeLine = 389;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1920x1200p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 389;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 389;
                        break ; 
                        } 
                    
                    goto case 6 ;
                    case 6 : 
                    
                        { 
                        __context__.SourceCodeLine = 390;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1920x1080p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 390;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 390;
                        break ; 
                        } 
                    
                    goto case 7 ;
                    case 7 : 
                    
                        { 
                        __context__.SourceCodeLine = 391;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1920x1080p50\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 391;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 391;
                        break ; 
                        } 
                    
                    goto case 8 ;
                    case 8 : 
                    
                        { 
                        __context__.SourceCodeLine = 392;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1600x1200p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 392;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 392;
                        break ; 
                        } 
                    
                    goto case 9 ;
                    case 9 : 
                    
                        { 
                        __context__.SourceCodeLine = 394;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1400x1050p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 394;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 394;
                        break ; 
                        } 
                    
                    goto case 10 ;
                    case 10 : 
                    
                        { 
                        __context__.SourceCodeLine = 395;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1366x768p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 395;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 395;
                        break ; 
                        } 
                    
                    goto case 11 ;
                    case 11 : 
                    
                        { 
                        __context__.SourceCodeLine = 396;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1360x768p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 396;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 396;
                        break ; 
                        } 
                    
                    goto case 12 ;
                    case 12 : 
                    
                        { 
                        __context__.SourceCodeLine = 397;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1280x1024p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 397;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 397;
                        break ; 
                        } 
                    
                    goto case 13 ;
                    case 13 : 
                    
                        { 
                        __context__.SourceCodeLine = 399;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1280x768p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 399;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 399;
                        break ; 
                        } 
                    
                    goto case 14 ;
                    case 14 : 
                    
                        { 
                        __context__.SourceCodeLine = 400;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1280x720p50\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 400;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 400;
                        break ; 
                        } 
                    
                    goto case 15 ;
                    case 15 : 
                    
                        { 
                        __context__.SourceCodeLine = 401;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1280x720p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 401;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 401;
                        break ; 
                        } 
                    
                    goto case 16 ;
                    case 16 : 
                    
                        { 
                        __context__.SourceCodeLine = 402;
                        MakeString ( CMD , "SET OUT{0:d} OUT-SIGNAL 1024x768p60\r", (short)PORT) ; 
                        __context__.SourceCodeLine = 402;
                        TX_BUFFER  .UpdateValue ( CMD  ) ; 
                        __context__.SourceCodeLine = 402;
                        break ; 
                        } 
                    
                    goto default;
                    default : 
                    
                        {
                        __context__.SourceCodeLine = 404;
                        break ; 
                        }
                    break;
                    
                    } 
                    
                
                } 
            
            else 
                {
                __context__.SourceCodeLine = 407;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DISPOSEMODE == 2))  ) ) 
                    { 
                    __context__.SourceCodeLine = 409;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (SIGNALSOURCE == 1))  ) ) 
                        { 
                        __context__.SourceCodeLine = 411;
                        ushort __FN_FORSTART_VAL__1 = (ushort) ( 0 ) ;
                        ushort __FN_FOREND_VAL__1 = (ushort)16; 
                        int __FN_FORSTEP_VAL__1 = (int)1; 
                        for ( II  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (II  >= __FN_FORSTART_VAL__1) && (II  <= __FN_FOREND_VAL__1) ) : ( (II  <= __FN_FORSTART_VAL__1) && (II  >= __FN_FOREND_VAL__1) ) ; II  += (ushort)__FN_FORSTEP_VAL__1) 
                            { 
                            __context__.SourceCodeLine = 413;
                            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_INSIGNALFORMAT[ II ] , SIGNALFORMAT ))  ) ) 
                                { 
                                __context__.SourceCodeLine = 415;
                                SIGNALFORMAT_FLAG = (ushort) ( II ) ; 
                                __context__.SourceCodeLine = 416;
                                break ; 
                                } 
                            
                            __context__.SourceCodeLine = 411;
                            } 
                        
                        __context__.SourceCodeLine = 419;
                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( PORT > 0 ) ) && Functions.TestForTrue ( Functions.BoolToInt ( PORT <= DEVICE_INPUT_NUM  .Value ) )) ))  ) ) 
                            {
                            __context__.SourceCodeLine = 419;
                            FB_INXFORMAT [ PORT]  .UpdateValue ( G_INSIGNALFORMAT [ SIGNALFORMAT_FLAG ]  ) ; 
                            }
                        
                        } 
                    
                    else 
                        {
                        __context__.SourceCodeLine = 422;
                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (SIGNALSOURCE == 2))  ) ) 
                            { 
                            __context__.SourceCodeLine = 425;
                            ushort __FN_FORSTART_VAL__2 = (ushort) ( 0 ) ;
                            ushort __FN_FOREND_VAL__2 = (ushort)16; 
                            int __FN_FORSTEP_VAL__2 = (int)1; 
                            for ( II  = __FN_FORSTART_VAL__2; (__FN_FORSTEP_VAL__2 > 0)  ? ( (II  >= __FN_FORSTART_VAL__2) && (II  <= __FN_FOREND_VAL__2) ) : ( (II  <= __FN_FORSTART_VAL__2) && (II  >= __FN_FOREND_VAL__2) ) ; II  += (ushort)__FN_FORSTEP_VAL__2) 
                                { 
                                __context__.SourceCodeLine = 428;
                                if ( Functions.TestForTrue  ( ( Functions.FindNoCase( G_OUTSIGNALFORMAT[ II ] , SIGNALFORMAT ))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 430;
                                    SIGNALFORMAT_FLAG = (ushort) ( II ) ; 
                                    __context__.SourceCodeLine = 431;
                                    break ; 
                                    } 
                                
                                __context__.SourceCodeLine = 425;
                                } 
                            
                            __context__.SourceCodeLine = 434;
                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( PORT > 0 ) ) && Functions.TestForTrue ( Functions.BoolToInt ( PORT <= DEVICE_OUTPUT_NUM  .Value ) )) ))  ) ) 
                                {
                                __context__.SourceCodeLine = 434;
                                FB_OUTXFORMAT [ PORT]  .Value = (ushort) ( SIGNALFORMAT_FLAG ) ; 
                                }
                            
                            } 
                        
                        }
                    
                    __context__.SourceCodeLine = 438;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                        {
                        __context__.SourceCodeLine = 438;
                        Print( "[SingalFormatProce] SignalFormat_Flag = {0:d}\r\n", (short)SIGNALFORMAT_FLAG) ; 
                        }
                    
                    } 
                
                }
            
            
            }
            
        private void GETTVWALLROWCOLUME (  SplusExecutionContext __context__, ushort SP_MODE ) 
            { 
            
            __context__.SourceCodeLine = 445;
            switch ((int)SP_MODE)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 449;
                    G_TVWALL_ROW = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 450;
                    G_TVWALL_COLUME = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 452;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 456;
                    G_TVWALL_ROW = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 457;
                    G_TVWALL_COLUME = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 459;
                    break ; 
                    } 
                
                goto case 3 ;
                case 3 : 
                
                    { 
                    __context__.SourceCodeLine = 463;
                    G_TVWALL_ROW = (ushort) ( 3 ) ; 
                    __context__.SourceCodeLine = 464;
                    G_TVWALL_COLUME = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 465;
                    break ; 
                    } 
                
                goto case 4 ;
                case 4 : 
                
                    { 
                    __context__.SourceCodeLine = 469;
                    G_TVWALL_ROW = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 470;
                    G_TVWALL_COLUME = (ushort) ( 3 ) ; 
                    __context__.SourceCodeLine = 471;
                    break ; 
                    } 
                
                goto case 5 ;
                case 5 : 
                
                    { 
                    __context__.SourceCodeLine = 475;
                    G_TVWALL_ROW = (ushort) ( 4 ) ; 
                    __context__.SourceCodeLine = 476;
                    G_TVWALL_COLUME = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 477;
                    break ; 
                    } 
                
                goto case 6 ;
                case 6 : 
                
                    { 
                    __context__.SourceCodeLine = 481;
                    G_TVWALL_ROW = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 482;
                    G_TVWALL_COLUME = (ushort) ( 4 ) ; 
                    __context__.SourceCodeLine = 483;
                    break ; 
                    } 
                
                goto case 7 ;
                case 7 : 
                
                    { 
                    __context__.SourceCodeLine = 487;
                    G_TVWALL_ROW = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 488;
                    G_TVWALL_COLUME = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 489;
                    break ; 
                    } 
                
                goto case 8 ;
                case 8 : 
                
                    { 
                    __context__.SourceCodeLine = 493;
                    G_TVWALL_ROW = (ushort) ( 3 ) ; 
                    __context__.SourceCodeLine = 494;
                    G_TVWALL_COLUME = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 495;
                    break ; 
                    } 
                
                goto case 9 ;
                case 9 : 
                
                    { 
                    __context__.SourceCodeLine = 499;
                    G_TVWALL_ROW = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 500;
                    G_TVWALL_COLUME = (ushort) ( 3 ) ; 
                    __context__.SourceCodeLine = 501;
                    break ; 
                    } 
                
                goto case 10 ;
                case 10 : 
                
                    { 
                    __context__.SourceCodeLine = 505;
                    G_TVWALL_ROW = (ushort) ( 4 ) ; 
                    __context__.SourceCodeLine = 506;
                    G_TVWALL_COLUME = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 507;
                    break ; 
                    } 
                
                goto case 11 ;
                case 11 : 
                
                    { 
                    __context__.SourceCodeLine = 511;
                    G_TVWALL_ROW = (ushort) ( 2 ) ; 
                    __context__.SourceCodeLine = 512;
                    G_TVWALL_COLUME = (ushort) ( 4 ) ; 
                    __context__.SourceCodeLine = 513;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 515;
                    break ; 
                    }
                break;
                
                } 
                
            
            __context__.SourceCodeLine = 518;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 520;
                Print( "TV Wall Row is {0:d}\r\n", (short)G_TVWALL_ROW) ; 
                __context__.SourceCodeLine = 521;
                Print( "TV Wall Colume is {0:d}\r\n", (short)G_TVWALL_COLUME) ; 
                } 
            
            
            }
            
        object SETMARGIN1X1_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                ushort A = 0;
                ushort B = 0;
                
                
                __context__.SourceCodeLine = 530;
                A = (ushort) ( 1 ) ; 
                __context__.SourceCodeLine = 531;
                B = (ushort) ( 1 ) ; 
                __context__.SourceCodeLine = 532;
                MakeString ( TX_BUFFER , "SET OUT1 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 1 ] .UshortValue, (short)OUTXMARGINRIGHT[ 1 ] .UshortValue, (short)OUTXMARGINTOP[ 1 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 1 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object SETMARGIN1X2_OnPush_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            ushort A = 0;
            ushort B = 0;
            
            
            __context__.SourceCodeLine = 540;
            A = (ushort) ( 1 ) ; 
            __context__.SourceCodeLine = 541;
            B = (ushort) ( 2 ) ; 
            __context__.SourceCodeLine = 542;
            MakeString ( TX_BUFFER , "SET OUT2 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 2 ] .UshortValue, (short)OUTXMARGINRIGHT[ 2 ] .UshortValue, (short)OUTXMARGINTOP[ 2 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 2 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object SETMARGIN1X3_OnPush_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort A = 0;
        ushort B = 0;
        
        
        __context__.SourceCodeLine = 551;
        A = (ushort) ( 1 ) ; 
        __context__.SourceCodeLine = 552;
        B = (ushort) ( 3 ) ; 
        __context__.SourceCodeLine = 553;
        MakeString ( TX_BUFFER , "SET OUT3 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 3 ] .UshortValue, (short)OUTXMARGINRIGHT[ 3 ] .UshortValue, (short)OUTXMARGINTOP[ 3 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 3 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETMARGIN1X4_OnPush_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort A = 0;
        ushort B = 0;
        
        
        __context__.SourceCodeLine = 561;
        A = (ushort) ( 1 ) ; 
        __context__.SourceCodeLine = 562;
        B = (ushort) ( 4 ) ; 
        __context__.SourceCodeLine = 563;
        MakeString ( TX_BUFFER , "SET OUT4 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 4 ] .UshortValue, (short)OUTXMARGINRIGHT[ 4 ] .UshortValue, (short)OUTXMARGINTOP[ 4 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 4 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETMARGIN2X1_OnPush_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort A = 0;
        ushort B = 0;
        
        
        __context__.SourceCodeLine = 571;
        A = (ushort) ( 2 ) ; 
        __context__.SourceCodeLine = 572;
        B = (ushort) ( 1 ) ; 
        __context__.SourceCodeLine = 573;
        MakeString ( TX_BUFFER , "SET OUT3 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 3 ] .UshortValue, (short)OUTXMARGINRIGHT[ 3 ] .UshortValue, (short)OUTXMARGINTOP[ 3 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 3 ] .UshortValue, (short)SETVIDEOROUTING[ 3 ] .UshortValue) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETMARGIN3X1_OnPush_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort A = 0;
        ushort B = 0;
        
        
        __context__.SourceCodeLine = 582;
        A = (ushort) ( 3 ) ; 
        __context__.SourceCodeLine = 583;
        B = (ushort) ( 1 ) ; 
        __context__.SourceCodeLine = 584;
        MakeString ( TX_BUFFER , "SET OUT3 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 3 ] .UshortValue, (short)OUTXMARGINRIGHT[ 3 ] .UshortValue, (short)OUTXMARGINTOP[ 3 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 3 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETMARGIN4X1_OnPush_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort A = 0;
        ushort B = 0;
        
        
        __context__.SourceCodeLine = 592;
        A = (ushort) ( 4 ) ; 
        __context__.SourceCodeLine = 593;
        B = (ushort) ( 1 ) ; 
        __context__.SourceCodeLine = 594;
        MakeString ( TX_BUFFER , "SET OUT4 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 4 ] .UshortValue, (short)OUTXMARGINRIGHT[ 4 ] .UshortValue, (short)OUTXMARGINTOP[ 4 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 4 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETMARGIN2X2_OnPush_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort A = 0;
        ushort B = 0;
        
        
        __context__.SourceCodeLine = 605;
        A = (ushort) ( 2 ) ; 
        __context__.SourceCodeLine = 606;
        B = (ushort) ( 2 ) ; 
        __context__.SourceCodeLine = 607;
        MakeString ( TX_BUFFER , "SET OUT4 TVWALL {0:d} {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d}\r", (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)A, (short)B, (short)OUTXMARGINLEFT[ 4 ] .UshortValue, (short)OUTXMARGINRIGHT[ 4 ] .UshortValue, (short)OUTXMARGINTOP[ 4 ] .UshortValue, (short)OUTXMARGINBOTTOM[ 4 ] .UshortValue, (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

private void SETTVWALLMODE (  SplusExecutionContext __context__, ushort SP_MODE ) 
    { 
    ushort II = 0;
    ushort JJ = 0;
    
    ushort INDEX = 0;
    
    
    __context__.SourceCodeLine = 639;
    GETTVWALLROWCOLUME (  __context__ , (ushort)( SP_MODE )) ; 
    __context__.SourceCodeLine = 640;
    FB_SETTVWALL  .Value = (ushort) ( (G_TVWALL_COLUME * G_TVWALL_ROW) ) ; 
    __context__.SourceCodeLine = 641;
    ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
    ushort __FN_FOREND_VAL__1 = (ushort)G_TVWALL_ROW; 
    int __FN_FORSTEP_VAL__1 = (int)1; 
    for ( II  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (II  >= __FN_FORSTART_VAL__1) && (II  <= __FN_FOREND_VAL__1) ) : ( (II  <= __FN_FORSTART_VAL__1) && (II  >= __FN_FOREND_VAL__1) ) ; II  += (ushort)__FN_FORSTEP_VAL__1) 
        { 
        __context__.SourceCodeLine = 642;
        ushort __FN_FORSTART_VAL__2 = (ushort) ( 1 ) ;
        ushort __FN_FOREND_VAL__2 = (ushort)G_TVWALL_COLUME; 
        int __FN_FORSTEP_VAL__2 = (int)1; 
        for ( JJ  = __FN_FORSTART_VAL__2; (__FN_FORSTEP_VAL__2 > 0)  ? ( (JJ  >= __FN_FORSTART_VAL__2) && (JJ  <= __FN_FOREND_VAL__2) ) : ( (JJ  <= __FN_FORSTART_VAL__2) && (JJ  >= __FN_FOREND_VAL__2) ) ; JJ  += (ushort)__FN_FORSTEP_VAL__2) 
            { 
            __context__.SourceCodeLine = 643;
            INDEX = (ushort) ( (JJ + ((II - 1) * G_TVWALL_COLUME)) ) ; 
            __context__.SourceCodeLine = 644;
            MakeString ( TX_BUFFER , "SET OUT{0:d} TVWALL {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d} {9:d}\r", (short)INDEX, (short)G_TVWALL_ROW, (short)G_TVWALL_COLUME, (short)II, (short)JJ, (short)G_TWPARAMETER.OUT1INIT[ 4 ], (short)G_TWPARAMETER.OUT1INIT[ 5 ], (short)G_TWPARAMETER.OUT1INIT[ 6 ], (short)G_TWPARAMETER.OUT1INIT[ 7 ], (short)SETVIDEOROUTING[ 1 ] .UshortValue) ; 
            __context__.SourceCodeLine = 646;
            Functions.Delay (  (int) ( 20 ) ) ; 
            __context__.SourceCodeLine = 642;
            } 
        
        __context__.SourceCodeLine = 641;
        } 
    
    
    }
    
private void SETTVWALLCANCEL (  SplusExecutionContext __context__, ushort SP_MODE ) 
    { 
    ushort INDEX = 0;
    ushort NUM = 0;
    
    
    __context__.SourceCodeLine = 663;
    GETTVWALLROWCOLUME (  __context__ , (ushort)( SP_MODE )) ; 
    __context__.SourceCodeLine = 664;
    NUM = (ushort) ( (G_TVWALL_COLUME * G_TVWALL_ROW) ) ; 
    __context__.SourceCodeLine = 665;
    ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
    ushort __FN_FOREND_VAL__1 = (ushort)NUM; 
    int __FN_FORSTEP_VAL__1 = (int)1; 
    for ( INDEX  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (INDEX  >= __FN_FORSTART_VAL__1) && (INDEX  <= __FN_FOREND_VAL__1) ) : ( (INDEX  <= __FN_FORSTART_VAL__1) && (INDEX  >= __FN_FOREND_VAL__1) ) ; INDEX  += (ushort)__FN_FORSTEP_VAL__1) 
        { 
        __context__.SourceCodeLine = 666;
        MakeString ( TX_BUFFER , "SET OUT{0:d} TVWALL {1:d} {2:d} {3:d} {4:d} {5:d} {6:d} {7:d} {8:d} {9:d}\r", (short)INDEX, (short)1, (short)1, (short)1, (short)1, (short)0, (short)0, (short)0, (short)0, (short)1) ; 
        __context__.SourceCodeLine = 667;
        Functions.Delay (  (int) ( 20 ) ) ; 
        __context__.SourceCodeLine = 665;
        } 
    
    
    }
    
private void ANALYSISDATAFROMDEVICE (  SplusExecutionContext __context__, CrestronString DATA ) 
    { 
    ushort INPUT_PORT = 0;
    
    ushort OUTPUT_PORT = 0;
    
    CrestronString PARS_CMD_BUFF;
    PARS_CMD_BUFF  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
    
    CrestronString CMD_HEAD;
    CMD_HEAD  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 64, this );
    
    ushort I = 0;
    
    
    __context__.SourceCodeLine = 682;
    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "SYS ROUTE-MODE " , DATA ))  ) ) 
        { 
        __context__.SourceCodeLine = 684;
        ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
        ushort __FN_FOREND_VAL__1 = (ushort)8; 
        int __FN_FORSTEP_VAL__1 = (int)1; 
        for ( I  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (I  >= __FN_FORSTART_VAL__1) && (I  <= __FN_FOREND_VAL__1) ) : ( (I  <= __FN_FORSTART_VAL__1) && (I  >= __FN_FOREND_VAL__1) ) ; I  += (ushort)__FN_FORSTEP_VAL__1) 
            { 
            __context__.SourceCodeLine = 686;
            FB_PRESET [ I]  .Value = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 684;
            } 
        
        __context__.SourceCodeLine = 688;
        FB_PRESET [ Functions.Atoi( DATA )]  .Value = (ushort) ( 1 ) ; 
        } 
    
    __context__.SourceCodeLine = 693;
    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "SYS AUDIO-SWMODE" , DATA ))  ) ) 
        { 
        __context__.SourceCodeLine = 695;
        PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( "SYS AUDIO-SWMODE" , DATA )  ) ; 
        __context__.SourceCodeLine = 697;
        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "MANUAL" , DATA ))  ) ) 
            { 
            __context__.SourceCodeLine = 699;
            AUDIOMODE_FLAG = (ushort) ( 1 ) ; 
            __context__.SourceCodeLine = 701;
            FB_AUDIOMODEAUTO  .Value = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 702;
            FB_AUDIOMODEMANUAL  .Value = (ushort) ( 1 ) ; 
            } 
        
        else 
            {
            __context__.SourceCodeLine = 704;
            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "AUTO" , DATA ))  ) ) 
                { 
                __context__.SourceCodeLine = 706;
                AUDIOMODE_FLAG = (ushort) ( 0 ) ; 
                __context__.SourceCodeLine = 708;
                FB_AUDIOMODEMANUAL  .Value = (ushort) ( 0 ) ; 
                __context__.SourceCodeLine = 709;
                FB_AUDIOMODEAUTO  .Value = (ushort) ( 1 ) ; 
                __context__.SourceCodeLine = 710;
                ushort __FN_FORSTART_VAL__2 = (ushort) ( 1 ) ;
                ushort __FN_FOREND_VAL__2 = (ushort)DEVICE_OUTPUT_NUM  .Value; 
                int __FN_FORSTEP_VAL__2 = (int)1; 
                for ( I  = __FN_FORSTART_VAL__2; (__FN_FORSTEP_VAL__2 > 0)  ? ( (I  >= __FN_FORSTART_VAL__2) && (I  <= __FN_FOREND_VAL__2) ) : ( (I  <= __FN_FORSTART_VAL__2) && (I  >= __FN_FOREND_VAL__2) ) ; I  += (ushort)__FN_FORSTEP_VAL__2) 
                    { 
                    __context__.SourceCodeLine = 712;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( AUDIOOUTPORT[ (I - 1) ] > 0 ) ) && Functions.TestForTrue ( Functions.BoolToInt ( AUDIOOUTPORT[ (I - 1) ] <= DEVICE_INPUT_NUM  .Value ) )) ))  ) ) 
                        { 
                        __context__.SourceCodeLine = 714;
                        FB_SETAUDIOROUTING [ AUDIOOUTPORT[ (I - 1) ]]  .Value = (ushort) ( G_TWPARAMETER.TWINPUTPORT[ I ] ) ; 
                        } 
                    
                    __context__.SourceCodeLine = 710;
                    } 
                
                } 
            
            }
        
        } 
    
    else 
        {
        __context__.SourceCodeLine = 725;
        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "SYS AUDIO-ONLY" , DATA ))  ) ) 
            { 
            __context__.SourceCodeLine = 727;
            PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( "SYS AUDIO-ONLY" , DATA )  ) ; 
            __context__.SourceCodeLine = 729;
            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "ON" , DATA ))  ) ) 
                { 
                __context__.SourceCodeLine = 731;
                FB_AUDIOONLYCLOSE  .Value = (ushort) ( 0 ) ; 
                __context__.SourceCodeLine = 732;
                FB_AUDIOONLYOPEN  .Value = (ushort) ( 1 ) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 734;
                if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "OFF" , DATA ))  ) ) 
                    { 
                    __context__.SourceCodeLine = 736;
                    FB_AUDIOONLYOPEN  .Value = (ushort) ( 0 ) ; 
                    __context__.SourceCodeLine = 737;
                    FB_AUDIOONLYCLOSE  .Value = (ushort) ( 1 ) ; 
                    } 
                
                }
            
            } 
        
        else 
            {
            __context__.SourceCodeLine = 744;
            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "AUDIO-SRC" , DATA ))  ) ) 
                { 
                __context__.SourceCodeLine = 746;
                PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( " AUDIO-SRC " , DATA )  ) ; 
                __context__.SourceCodeLine = 747;
                INPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 3 ) , (int)( 1 ) ) ) ) ; 
                __context__.SourceCodeLine = 749;
                if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "EMBEDDED" , DATA ))  ) ) 
                    { 
                    __context__.SourceCodeLine = 751;
                    FB_SETINXAUDIOLR [ INPUT_PORT]  .Value = (ushort) ( 0 ) ; 
                    __context__.SourceCodeLine = 752;
                    FB_SETINXAUDIOEMBEDDED [ INPUT_PORT]  .Value = (ushort) ( 1 ) ; 
                    } 
                
                else 
                    {
                    __context__.SourceCodeLine = 754;
                    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "L/R" , DATA ))  ) ) 
                        { 
                        __context__.SourceCodeLine = 756;
                        FB_SETINXAUDIOEMBEDDED [ INPUT_PORT]  .Value = (ushort) ( 0 ) ; 
                        __context__.SourceCodeLine = 757;
                        FB_SETINXAUDIOLR [ INPUT_PORT]  .Value = (ushort) ( 1 ) ; 
                        } 
                    
                    }
                
                } 
            
            else 
                {
                __context__.SourceCodeLine = 764;
                if ( Functions.TestForTrue  ( ( Functions.FindNoCase( " VIDEO " , DATA ))  ) ) 
                    { 
                    __context__.SourceCodeLine = 767;
                    PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( " VIDEO " , DATA )  ) ; 
                    __context__.SourceCodeLine = 769;
                    CMD_HEAD  .UpdateValue ( Functions.Left ( PARS_CMD_BUFF ,  (int) ( 2 ) )  ) ; 
                    __context__.SourceCodeLine = 772;
                    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "IN" , CMD_HEAD ))  ) ) 
                        { 
                        __context__.SourceCodeLine = 774;
                        INPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 3 ) , (int)( 1 ) ) ) ) ; 
                        __context__.SourceCodeLine = 775;
                        OUTPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( DATA , (int)( 4 ) , (int)( 1 ) ) ) ) ; 
                        __context__.SourceCodeLine = 776;
                        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "ALL" , PARS_CMD_BUFF ))  ) ) 
                            { 
                            __context__.SourceCodeLine = 778;
                            INPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( DATA , (int)( 3 ) , (int)( 1 ) ) ) ) ; 
                            __context__.SourceCodeLine = 779;
                            ushort __FN_FORSTART_VAL__3 = (ushort) ( 1 ) ;
                            ushort __FN_FOREND_VAL__3 = (ushort)DEVICE_OUTPUT_NUM  .Value; 
                            int __FN_FORSTEP_VAL__3 = (int)1; 
                            for ( I  = __FN_FORSTART_VAL__3; (__FN_FORSTEP_VAL__3 > 0)  ? ( (I  >= __FN_FORSTART_VAL__3) && (I  <= __FN_FOREND_VAL__3) ) : ( (I  <= __FN_FORSTART_VAL__3) && (I  >= __FN_FOREND_VAL__3) ) ; I  += (ushort)__FN_FORSTEP_VAL__3) 
                                { 
                                __context__.SourceCodeLine = 781;
                                FB_SETVIDEOROUTING [ I]  .Value = (ushort) ( INPUT_PORT ) ; 
                                __context__.SourceCodeLine = 779;
                                } 
                            
                            } 
                        
                        else 
                            {
                            __context__.SourceCodeLine = 784;
                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 1))  ) ) 
                                { 
                                __context__.SourceCodeLine = 784;
                                AUDIOOUTPORT [ 0] = (ushort) ( 1 ) ; 
                                __context__.SourceCodeLine = 784;
                                G_TWPARAMETER . TWINPUTPORT [ 0] = (ushort) ( INPUT_PORT ) ; 
                                } 
                            
                            else 
                                {
                                __context__.SourceCodeLine = 785;
                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 2))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 785;
                                    AUDIOOUTPORT [ 1] = (ushort) ( 2 ) ; 
                                    __context__.SourceCodeLine = 785;
                                    G_TWPARAMETER . TWINPUTPORT [ 1] = (ushort) ( INPUT_PORT ) ; 
                                    } 
                                
                                else 
                                    {
                                    __context__.SourceCodeLine = 786;
                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 3))  ) ) 
                                        { 
                                        __context__.SourceCodeLine = 786;
                                        AUDIOOUTPORT [ 2] = (ushort) ( 3 ) ; 
                                        __context__.SourceCodeLine = 786;
                                        G_TWPARAMETER . TWINPUTPORT [ 2] = (ushort) ( INPUT_PORT ) ; 
                                        } 
                                    
                                    else 
                                        {
                                        __context__.SourceCodeLine = 787;
                                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 4))  ) ) 
                                            { 
                                            __context__.SourceCodeLine = 787;
                                            AUDIOOUTPORT [ 3] = (ushort) ( 4 ) ; 
                                            __context__.SourceCodeLine = 787;
                                            G_TWPARAMETER . TWINPUTPORT [ 3] = (ushort) ( INPUT_PORT ) ; 
                                            } 
                                        
                                        else 
                                            {
                                            __context__.SourceCodeLine = 788;
                                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 5))  ) ) 
                                                { 
                                                __context__.SourceCodeLine = 788;
                                                AUDIOOUTPORT [ 4] = (ushort) ( 5 ) ; 
                                                __context__.SourceCodeLine = 788;
                                                G_TWPARAMETER . TWINPUTPORT [ 4] = (ushort) ( INPUT_PORT ) ; 
                                                } 
                                            
                                            else 
                                                {
                                                __context__.SourceCodeLine = 789;
                                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 6))  ) ) 
                                                    { 
                                                    __context__.SourceCodeLine = 789;
                                                    AUDIOOUTPORT [ 5] = (ushort) ( 6 ) ; 
                                                    __context__.SourceCodeLine = 789;
                                                    G_TWPARAMETER . TWINPUTPORT [ 5] = (ushort) ( INPUT_PORT ) ; 
                                                    } 
                                                
                                                else 
                                                    {
                                                    __context__.SourceCodeLine = 790;
                                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 7))  ) ) 
                                                        { 
                                                        __context__.SourceCodeLine = 790;
                                                        AUDIOOUTPORT [ 6] = (ushort) ( 7 ) ; 
                                                        __context__.SourceCodeLine = 790;
                                                        G_TWPARAMETER . TWINPUTPORT [ 6] = (ushort) ( INPUT_PORT ) ; 
                                                        } 
                                                    
                                                    else 
                                                        {
                                                        __context__.SourceCodeLine = 791;
                                                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 8))  ) ) 
                                                            { 
                                                            __context__.SourceCodeLine = 791;
                                                            AUDIOOUTPORT [ 7] = (ushort) ( 8 ) ; 
                                                            __context__.SourceCodeLine = 791;
                                                            G_TWPARAMETER . TWINPUTPORT [ 7] = (ushort) ( INPUT_PORT ) ; 
                                                            } 
                                                        
                                                        }
                                                    
                                                    }
                                                
                                                }
                                            
                                            }
                                        
                                        }
                                    
                                    }
                                
                                }
                            
                            }
                        
                        __context__.SourceCodeLine = 793;
                        VIDEOROUTINGDISPOSE (  __context__ , (ushort)( INPUT_PORT ), (ushort)( OUTPUT_PORT )) ; 
                        __context__.SourceCodeLine = 794;
                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (AUDIOMODE_FLAG == 0))  ) ) 
                            { 
                            __context__.SourceCodeLine = 796;
                            ushort __FN_FORSTART_VAL__4 = (ushort) ( 0 ) ;
                            ushort __FN_FOREND_VAL__4 = (ushort)7; 
                            int __FN_FORSTEP_VAL__4 = (int)1; 
                            for ( I  = __FN_FORSTART_VAL__4; (__FN_FORSTEP_VAL__4 > 0)  ? ( (I  >= __FN_FORSTART_VAL__4) && (I  <= __FN_FOREND_VAL__4) ) : ( (I  <= __FN_FORSTART_VAL__4) && (I  >= __FN_FOREND_VAL__4) ) ; I  += (ushort)__FN_FORSTEP_VAL__4) 
                                { 
                                __context__.SourceCodeLine = 798;
                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (AUDIOOUTPORT[ I ] != 0))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 799;
                                    FB_SETAUDIOROUTING [ AUDIOOUTPORT[ I ]]  .Value = (ushort) ( G_TWPARAMETER.TWINPUTPORT[ I ] ) ; 
                                    } 
                                
                                __context__.SourceCodeLine = 796;
                                } 
                            
                            } 
                        
                        } 
                    
                    else 
                        {
                        __context__.SourceCodeLine = 806;
                        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "OU" , CMD_HEAD ))  ) ) 
                            { 
                            __context__.SourceCodeLine = 808;
                            OUTPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 4 ) , (int)( 1 ) ) ) ) ; 
                            __context__.SourceCodeLine = 809;
                            INPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( DATA , (int)( 3 ) , (int)( 1 ) ) ) ) ; 
                            __context__.SourceCodeLine = 811;
                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 1))  ) ) 
                                { 
                                __context__.SourceCodeLine = 811;
                                AUDIOOUTPORT [ 0] = (ushort) ( 1 ) ; 
                                __context__.SourceCodeLine = 811;
                                G_TWPARAMETER . TWINPUTPORT [ 0] = (ushort) ( INPUT_PORT ) ; 
                                } 
                            
                            else 
                                {
                                __context__.SourceCodeLine = 812;
                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 2))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 812;
                                    AUDIOOUTPORT [ 1] = (ushort) ( 2 ) ; 
                                    __context__.SourceCodeLine = 812;
                                    G_TWPARAMETER . TWINPUTPORT [ 1] = (ushort) ( INPUT_PORT ) ; 
                                    } 
                                
                                else 
                                    {
                                    __context__.SourceCodeLine = 813;
                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 3))  ) ) 
                                        { 
                                        __context__.SourceCodeLine = 813;
                                        AUDIOOUTPORT [ 2] = (ushort) ( 3 ) ; 
                                        __context__.SourceCodeLine = 813;
                                        G_TWPARAMETER . TWINPUTPORT [ 2] = (ushort) ( INPUT_PORT ) ; 
                                        } 
                                    
                                    else 
                                        {
                                        __context__.SourceCodeLine = 814;
                                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 4))  ) ) 
                                            { 
                                            __context__.SourceCodeLine = 814;
                                            AUDIOOUTPORT [ 3] = (ushort) ( 4 ) ; 
                                            __context__.SourceCodeLine = 814;
                                            G_TWPARAMETER . TWINPUTPORT [ 3] = (ushort) ( INPUT_PORT ) ; 
                                            } 
                                        
                                        else 
                                            {
                                            __context__.SourceCodeLine = 815;
                                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 5))  ) ) 
                                                { 
                                                __context__.SourceCodeLine = 815;
                                                AUDIOOUTPORT [ 4] = (ushort) ( 5 ) ; 
                                                __context__.SourceCodeLine = 815;
                                                G_TWPARAMETER . TWINPUTPORT [ 4] = (ushort) ( INPUT_PORT ) ; 
                                                } 
                                            
                                            else 
                                                {
                                                __context__.SourceCodeLine = 816;
                                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 6))  ) ) 
                                                    { 
                                                    __context__.SourceCodeLine = 816;
                                                    AUDIOOUTPORT [ 5] = (ushort) ( 6 ) ; 
                                                    __context__.SourceCodeLine = 816;
                                                    G_TWPARAMETER . TWINPUTPORT [ 5] = (ushort) ( INPUT_PORT ) ; 
                                                    } 
                                                
                                                else 
                                                    {
                                                    __context__.SourceCodeLine = 817;
                                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 7))  ) ) 
                                                        { 
                                                        __context__.SourceCodeLine = 817;
                                                        AUDIOOUTPORT [ 6] = (ushort) ( 7 ) ; 
                                                        __context__.SourceCodeLine = 817;
                                                        G_TWPARAMETER . TWINPUTPORT [ 6] = (ushort) ( INPUT_PORT ) ; 
                                                        } 
                                                    
                                                    else 
                                                        {
                                                        __context__.SourceCodeLine = 818;
                                                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT_PORT == 8))  ) ) 
                                                            { 
                                                            __context__.SourceCodeLine = 818;
                                                            AUDIOOUTPORT [ 7] = (ushort) ( 8 ) ; 
                                                            __context__.SourceCodeLine = 818;
                                                            G_TWPARAMETER . TWINPUTPORT [ 7] = (ushort) ( INPUT_PORT ) ; 
                                                            } 
                                                        
                                                        }
                                                    
                                                    }
                                                
                                                }
                                            
                                            }
                                        
                                        }
                                    
                                    }
                                
                                }
                            
                            __context__.SourceCodeLine = 819;
                            VIDEOROUTINGDISPOSE (  __context__ , (ushort)( INPUT_PORT ), (ushort)( OUTPUT_PORT )) ; 
                            __context__.SourceCodeLine = 821;
                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (AUDIOMODE_FLAG == 0))  ) ) 
                                { 
                                __context__.SourceCodeLine = 823;
                                ushort __FN_FORSTART_VAL__5 = (ushort) ( 0 ) ;
                                ushort __FN_FOREND_VAL__5 = (ushort)7; 
                                int __FN_FORSTEP_VAL__5 = (int)1; 
                                for ( I  = __FN_FORSTART_VAL__5; (__FN_FORSTEP_VAL__5 > 0)  ? ( (I  >= __FN_FORSTART_VAL__5) && (I  <= __FN_FOREND_VAL__5) ) : ( (I  <= __FN_FORSTART_VAL__5) && (I  >= __FN_FOREND_VAL__5) ) ; I  += (ushort)__FN_FORSTEP_VAL__5) 
                                    { 
                                    __context__.SourceCodeLine = 825;
                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( AUDIOOUTPORT[ I ] > 0 ) ) && Functions.TestForTrue ( Functions.BoolToInt ( AUDIOOUTPORT[ I ] <= DEVICE_INPUT_NUM  .Value ) )) ))  ) ) 
                                        { 
                                        __context__.SourceCodeLine = 827;
                                        FB_SETAUDIOROUTING [ AUDIOOUTPORT[ I ]]  .Value = (ushort) ( G_TWPARAMETER.TWINPUTPORT[ I ] ) ; 
                                        } 
                                    
                                    __context__.SourceCodeLine = 823;
                                    } 
                                
                                } 
                            
                            } 
                        
                        }
                    
                    } 
                
                else 
                    {
                    __context__.SourceCodeLine = 837;
                    if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "AUDIO-ROUTE" , DATA ))  ) ) 
                        { 
                        __context__.SourceCodeLine = 839;
                        PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( " AUDIO-ROUTE " , DATA )  ) ; 
                        __context__.SourceCodeLine = 841;
                        CMD_HEAD  .UpdateValue ( Functions.Left ( PARS_CMD_BUFF ,  (int) ( 2 ) )  ) ; 
                        __context__.SourceCodeLine = 844;
                        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "IN" , CMD_HEAD ))  ) ) 
                            { 
                            __context__.SourceCodeLine = 846;
                            INPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 3 ) , (int)( 1 ) ) ) ) ; 
                            __context__.SourceCodeLine = 847;
                            OUTPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( DATA , (int)( 4 ) , (int)( 1 ) ) ) ) ; 
                            __context__.SourceCodeLine = 848;
                            FB_SETAUDIOROUTING [ OUTPUT_PORT]  .Value = (ushort) ( INPUT_PORT ) ; 
                            } 
                        
                        else 
                            {
                            __context__.SourceCodeLine = 853;
                            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( "OU" , CMD_HEAD ))  ) ) 
                                { 
                                __context__.SourceCodeLine = 855;
                                OUTPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 4 ) , (int)( 1 ) ) ) ) ; 
                                __context__.SourceCodeLine = 856;
                                INPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( DATA , (int)( 3 ) , (int)( 1 ) ) ) ) ; 
                                __context__.SourceCodeLine = 857;
                                FB_SETAUDIOROUTING [ OUTPUT_PORT]  .Value = (ushort) ( INPUT_PORT ) ; 
                                } 
                            
                            }
                        
                        } 
                    
                    else 
                        {
                        __context__.SourceCodeLine = 864;
                        if ( Functions.TestForTrue  ( ( Functions.FindNoCase( " IN-SIGNAL " , DATA ))  ) ) 
                            { 
                            __context__.SourceCodeLine = 866;
                            PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( " IN-SIGNAL " , DATA )  ) ; 
                            __context__.SourceCodeLine = 868;
                            INPUT_PORT = (ushort) ( Functions.Atoi( PARS_CMD_BUFF ) ) ; 
                            __context__.SourceCodeLine = 874;
                            SINGALFORMATPROCE (  __context__ , (ushort)( 2 ), (ushort)( INPUT_PORT ), (ushort)( 0 ), DATA, (ushort)( 1 )) ; 
                            } 
                        
                        else 
                            {
                            __context__.SourceCodeLine = 894;
                            if ( Functions.TestForTrue  ( ( Functions.FindNoCase( " OUT-SIGNAL " , DATA ))  ) ) 
                                { 
                                __context__.SourceCodeLine = 896;
                                PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( " OUT-SIGNAL " , DATA )  ) ; 
                                __context__.SourceCodeLine = 898;
                                OUTPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 4 ) , (int)( 1 ) ) ) ) ; 
                                __context__.SourceCodeLine = 899;
                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 901;
                                    Print( "[RxString] Output_port = {0:d}\r\n", (short)OUTPUT_PORT) ; 
                                    __context__.SourceCodeLine = 902;
                                    Print( "[RxString] SignalFormat = {0}\r\n", DATA ) ; 
                                    } 
                                
                                __context__.SourceCodeLine = 904;
                                SINGALFORMATPROCE (  __context__ , (ushort)( 2 ), (ushort)( OUTPUT_PORT ), (ushort)( 0 ), DATA, (ushort)( 2 )) ; 
                                } 
                            
                            else 
                                {
                                __context__.SourceCodeLine = 910;
                                if ( Functions.TestForTrue  ( ( Functions.FindNoCase( " OUT-TYPE " , DATA ))  ) ) 
                                    { 
                                    __context__.SourceCodeLine = 912;
                                    PARS_CMD_BUFF  .UpdateValue ( Functions.Remove ( " OUT-TYPE " , DATA )  ) ; 
                                    __context__.SourceCodeLine = 914;
                                    OUTPUT_PORT = (ushort) ( Functions.Atoi( Functions.Mid( PARS_CMD_BUFF , (int)( 4 ) , (int)( 1 ) ) ) ) ; 
                                    __context__.SourceCodeLine = 916;
                                    SINGALTYPEPOSE (  __context__ , (ushort)( 2 ), (ushort)( OUTPUT_PORT ), (ushort)( 0 ), DATA) ; 
                                    } 
                                
                                }
                            
                            }
                        
                        }
                    
                    }
                
                }
            
            }
        
        }
    
    
    }
    
object GETSYSTEMSTATUS_OnPush_8 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 926;
        GETMYSYSTEMSTATE (  __context__  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIOONLYOPEN_OnPush_9 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 931;
        TX_BUFFER  .UpdateValue ( "SET SYS AUDIO-ONLY ON\r"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIOONLYCLOSE_OnPush_10 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 936;
        TX_BUFFER  .UpdateValue ( "SET SYS AUDIO-ONLY OFF\r"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIOMODEMANUAL_OnPush_11 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 941;
        TX_BUFFER  .UpdateValue ( "SET SYS AUDIO-SWMODE MANUAL\r"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIOMODEAUTO_OnPush_12 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 946;
        TX_BUFFER  .UpdateValue ( "SET SYS AUDIO-SWMODE AUTO\r"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object PRESET_RECALL_OnPush_13 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 952;
        MakeString ( TX_BUFFER , "GET SYS ROUTE-MODE {0:d}\r", (short)Functions.GetLastModifiedArrayIndex( __SignalEventArg__ )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object PRESET_SAVE_OnPush_14 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 957;
        MakeString ( TX_BUFFER , "SET SYS ROUTE-MODE {0:d}\r", (short)Functions.GetLastModifiedArrayIndex( __SignalEventArg__ )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object GETINXFORMATSTATUS_OnPush_15 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort JJ = 0;
        
        
        __context__.SourceCodeLine = 962;
        ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
        ushort __FN_FOREND_VAL__1 = (ushort)DEVICE_INPUT_NUM  .Value; 
        int __FN_FORSTEP_VAL__1 = (int)1; 
        for ( JJ  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (JJ  >= __FN_FORSTART_VAL__1) && (JJ  <= __FN_FOREND_VAL__1) ) : ( (JJ  <= __FN_FORSTART_VAL__1) && (JJ  >= __FN_FOREND_VAL__1) ) ; JJ  += (ushort)__FN_FORSTEP_VAL__1) 
            { 
            __context__.SourceCodeLine = 963;
            MakeString ( TX_BUFFER , "GET IN{0:d} IN-SIGNAL\r", (short)JJ) ; 
            __context__.SourceCodeLine = 964;
            Functions.Delay (  (int) ( 20 ) ) ; 
            __context__.SourceCodeLine = 962;
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object GETOUTXFORMATSTATUS_OnPush_16 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort JJ = 0;
        
        
        __context__.SourceCodeLine = 972;
        ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
        ushort __FN_FOREND_VAL__1 = (ushort)DEVICE_OUTPUT_NUM  .Value; 
        int __FN_FORSTEP_VAL__1 = (int)1; 
        for ( JJ  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (JJ  >= __FN_FORSTART_VAL__1) && (JJ  <= __FN_FOREND_VAL__1) ) : ( (JJ  <= __FN_FORSTART_VAL__1) && (JJ  >= __FN_FOREND_VAL__1) ) ; JJ  += (ushort)__FN_FORSTEP_VAL__1) 
            { 
            __context__.SourceCodeLine = 973;
            MakeString ( TX_BUFFER , "GET OUT{0:d} OUT-SIGNAL\r", (short)JJ) ; 
            __context__.SourceCodeLine = 974;
            Functions.Delay (  (int) ( 20 ) ) ; 
            __context__.SourceCodeLine = 972;
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object GETOUTXTYPESTATUS_OnPush_17 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort JJ = 0;
        
        
        __context__.SourceCodeLine = 982;
        ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
        ushort __FN_FOREND_VAL__1 = (ushort)DEVICE_OUTPUT_NUM  .Value; 
        int __FN_FORSTEP_VAL__1 = (int)1; 
        for ( JJ  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (JJ  >= __FN_FORSTART_VAL__1) && (JJ  <= __FN_FOREND_VAL__1) ) : ( (JJ  <= __FN_FORSTART_VAL__1) && (JJ  >= __FN_FOREND_VAL__1) ) ; JJ  += (ushort)__FN_FORSTEP_VAL__1) 
            { 
            __context__.SourceCodeLine = 983;
            MakeString ( TX_BUFFER , "GET OUT{0:d} OUT-TYPE\r", (short)JJ) ; 
            __context__.SourceCodeLine = 984;
            Functions.Delay (  (int) ( 20 ) ) ; 
            __context__.SourceCodeLine = 982;
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETINXAUDIOEMBEDDED_OnPush_18 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString CMD;
        CMD  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
        
        ushort AUDIOINPUT_EMBEDDED = 0;
        
        
        __context__.SourceCodeLine = 996;
        AUDIOINPUT_EMBEDDED = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 998;
        MakeString ( CMD , "SET IN{0:d} AUDIO-SRC EMBEDDED\r", (short)AUDIOINPUT_EMBEDDED) ; 
        __context__.SourceCodeLine = 1000;
        TX_BUFFER  .UpdateValue ( CMD  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETINXAUDIOLR_OnPush_19 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString CMD;
        CMD  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
        
        ushort AUDIOINPUT_LR = 0;
        
        
        __context__.SourceCodeLine = 1009;
        AUDIOINPUT_LR = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1011;
        MakeString ( CMD , "SET IN{0:d} AUDIO-SRC L/R\r", (short)AUDIOINPUT_LR) ; 
        __context__.SourceCodeLine = 1013;
        TX_BUFFER  .UpdateValue ( CMD  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object CANCELTVWALL_OnPush_20 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 1019;
        SETTVWALLCANCEL (  __context__ , (ushort)( G_TWPARAMETER.TVWALLMODE )) ; 
        __context__.SourceCodeLine = 1020;
        G_TWPARAMETER . TVWALLMODE = (ushort) ( 0 ) ; 
        __context__.SourceCodeLine = 1021;
        FB_SETTVWALL  .Value = (ushort) ( 0 ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETVIDEOROUTING_OnChange_21 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 1026;
        SETAVROUTING (  __context__ , (ushort)( 1 ), (ushort)( SETVIDEOROUTING[ Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ] .UshortValue ), (ushort)( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETAUDIOROUTING_OnChange_22 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 1032;
        SETAVROUTING (  __context__ , (ushort)( 2 ), (ushort)( SETAUDIOROUTING[ Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ] .UshortValue ), (ushort)( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETOUTPUTFORMAT_OnChange_23 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort OUTSIGNAL_FORMAT = 0;
        
        
        __context__.SourceCodeLine = 1039;
        OUTSIGNAL_FORMAT = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1041;
        SINGALFORMATPROCE (  __context__ , (ushort)( 1 ), (ushort)( OUTSIGNAL_FORMAT ), (ushort)( SETOUTPUTFORMAT[ OUTSIGNAL_FORMAT ] .UshortValue ), " ", (ushort)( 0 )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETOUTTYPE_OnChange_24 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort OUTSIGNAL_TYPE = 0;
        
        
        __context__.SourceCodeLine = 1049;
        OUTSIGNAL_TYPE = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1051;
        SINGALTYPEPOSE (  __context__ , (ushort)( 1 ), (ushort)( OUTSIGNAL_TYPE ), (ushort)( SETOUTTYPE[ OUTSIGNAL_TYPE ] .UshortValue ), " ") ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SETTVWALL_OnChange_25 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 1060;
        G_TWPARAMETER . TVWALLMODE = (ushort) ( SETTVWALL  .UshortValue ) ; 
        __context__.SourceCodeLine = 1063;
        SETTVWALLMODE (  __context__ , (ushort)( SETTVWALL  .UshortValue )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTXMARGINLEFT_OnChange_26 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort TVNUMBER = 0;
        
        
        __context__.SourceCodeLine = 1073;
        TVNUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1075;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue <= 100 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue >= 0 ) )) ))  ) ) 
            { 
            __context__.SourceCodeLine = 1077;
            switch ((int)TVNUMBER)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 1079;
                    G_TWPARAMETER . OUT1INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1079;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1079;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 1080;
                    G_TWPARAMETER . OUT2INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1080;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1080;
                    break ; 
                    } 
                
                goto case 3 ;
                case 3 : 
                
                    { 
                    __context__.SourceCodeLine = 1081;
                    G_TWPARAMETER . OUT3INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1081;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1081;
                    break ; 
                    } 
                
                goto case 4 ;
                case 4 : 
                
                    { 
                    __context__.SourceCodeLine = 1082;
                    G_TWPARAMETER . OUT4INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1082;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1082;
                    break ; 
                    } 
                
                goto case 5 ;
                case 5 : 
                
                    { 
                    __context__.SourceCodeLine = 1083;
                    G_TWPARAMETER . OUT5INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1083;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1083;
                    break ; 
                    } 
                
                goto case 6 ;
                case 6 : 
                
                    { 
                    __context__.SourceCodeLine = 1084;
                    G_TWPARAMETER . OUT6INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1084;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1084;
                    break ; 
                    } 
                
                goto case 7 ;
                case 7 : 
                
                    { 
                    __context__.SourceCodeLine = 1085;
                    G_TWPARAMETER . OUT7INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1085;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1085;
                    break ; 
                    } 
                
                goto case 8 ;
                case 8 : 
                
                    { 
                    __context__.SourceCodeLine = 1086;
                    G_TWPARAMETER . OUT8INIT [ 4] = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1086;
                    FB_OUTXMARGINLEFT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINLEFT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1086;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 1087;
                    break ; 
                    }
                break;
                
                } 
                
            
            } 
        
        else 
            { 
            __context__.SourceCodeLine = 1091;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 1093;
                Print( "OutxMarginLeft is out of range,the valid range is 0~100!\r\n") ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTXMARGINRIGHT_OnChange_27 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort TVNUMBER = 0;
        
        
        __context__.SourceCodeLine = 1101;
        TVNUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1103;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue <= 100 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue >= 0 ) )) ))  ) ) 
            { 
            __context__.SourceCodeLine = 1105;
            switch ((int)TVNUMBER)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 1107;
                    G_TWPARAMETER . OUT1INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1107;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1107;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 1108;
                    G_TWPARAMETER . OUT2INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1108;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1108;
                    break ; 
                    } 
                
                goto case 3 ;
                case 3 : 
                
                    { 
                    __context__.SourceCodeLine = 1109;
                    G_TWPARAMETER . OUT3INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1109;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1109;
                    break ; 
                    } 
                
                goto case 4 ;
                case 4 : 
                
                    { 
                    __context__.SourceCodeLine = 1110;
                    G_TWPARAMETER . OUT4INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1110;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1110;
                    break ; 
                    } 
                
                goto case 5 ;
                case 5 : 
                
                    { 
                    __context__.SourceCodeLine = 1111;
                    G_TWPARAMETER . OUT5INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1111;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1111;
                    break ; 
                    } 
                
                goto case 6 ;
                case 6 : 
                
                    { 
                    __context__.SourceCodeLine = 1112;
                    G_TWPARAMETER . OUT6INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1112;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1112;
                    break ; 
                    } 
                
                goto case 7 ;
                case 7 : 
                
                    { 
                    __context__.SourceCodeLine = 1113;
                    G_TWPARAMETER . OUT7INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1113;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1113;
                    break ; 
                    } 
                
                goto case 8 ;
                case 8 : 
                
                    { 
                    __context__.SourceCodeLine = 1114;
                    G_TWPARAMETER . OUT8INIT [ 5] = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1114;
                    FB_OUTXMARGINRIGHT [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINRIGHT[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1114;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 1115;
                    break ; 
                    }
                break;
                
                } 
                
            
            } 
        
        else 
            { 
            __context__.SourceCodeLine = 1119;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 1121;
                Print( "OutxMarginRight is out of range,the valid range is 0~100!\r\n") ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTXMARGINTOP_OnChange_28 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort TVNUMBER = 0;
        
        
        __context__.SourceCodeLine = 1129;
        TVNUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1131;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue <= 100 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue >= 0 ) )) ))  ) ) 
            { 
            __context__.SourceCodeLine = 1133;
            switch ((int)TVNUMBER)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 1135;
                    G_TWPARAMETER . OUT1INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1135;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1135;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 1136;
                    G_TWPARAMETER . OUT2INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1136;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1136;
                    break ; 
                    } 
                
                goto case 3 ;
                case 3 : 
                
                    { 
                    __context__.SourceCodeLine = 1137;
                    G_TWPARAMETER . OUT3INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1137;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1137;
                    break ; 
                    } 
                
                goto case 4 ;
                case 4 : 
                
                    { 
                    __context__.SourceCodeLine = 1138;
                    G_TWPARAMETER . OUT4INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1138;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1138;
                    break ; 
                    } 
                
                goto case 5 ;
                case 5 : 
                
                    { 
                    __context__.SourceCodeLine = 1139;
                    G_TWPARAMETER . OUT5INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1139;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1139;
                    break ; 
                    } 
                
                goto case 6 ;
                case 6 : 
                
                    { 
                    __context__.SourceCodeLine = 1140;
                    G_TWPARAMETER . OUT6INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1140;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1140;
                    break ; 
                    } 
                
                goto case 7 ;
                case 7 : 
                
                    { 
                    __context__.SourceCodeLine = 1141;
                    G_TWPARAMETER . OUT7INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1141;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1141;
                    break ; 
                    } 
                
                goto case 8 ;
                case 8 : 
                
                    { 
                    __context__.SourceCodeLine = 1142;
                    G_TWPARAMETER . OUT8INIT [ 6] = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1142;
                    FB_OUTXMARGINTOP [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINTOP[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1142;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 1143;
                    break ; 
                    }
                break;
                
                } 
                
            
            } 
        
        else 
            { 
            __context__.SourceCodeLine = 1147;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 1149;
                Print( "OutxMarginTop is out of range,the valid range is 0~100!\r\n") ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTXMARGINBOTTOM_OnChange_29 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort TVNUMBER = 0;
        
        
        __context__.SourceCodeLine = 1157;
        TVNUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 1159;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue <= 100 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue >= 0 ) )) ))  ) ) 
            { 
            __context__.SourceCodeLine = 1161;
            switch ((int)TVNUMBER)
            
                { 
                case 1 : 
                
                    { 
                    __context__.SourceCodeLine = 1163;
                    G_TWPARAMETER . OUT1INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1163;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1163;
                    break ; 
                    } 
                
                goto case 2 ;
                case 2 : 
                
                    { 
                    __context__.SourceCodeLine = 1164;
                    G_TWPARAMETER . OUT2INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1164;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1164;
                    break ; 
                    } 
                
                goto case 3 ;
                case 3 : 
                
                    { 
                    __context__.SourceCodeLine = 1165;
                    G_TWPARAMETER . OUT3INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1165;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1165;
                    break ; 
                    } 
                
                goto case 4 ;
                case 4 : 
                
                    { 
                    __context__.SourceCodeLine = 1166;
                    G_TWPARAMETER . OUT4INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1166;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1166;
                    break ; 
                    } 
                
                goto case 5 ;
                case 5 : 
                
                    { 
                    __context__.SourceCodeLine = 1167;
                    G_TWPARAMETER . OUT5INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1167;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1167;
                    break ; 
                    } 
                
                goto case 6 ;
                case 6 : 
                
                    { 
                    __context__.SourceCodeLine = 1168;
                    G_TWPARAMETER . OUT6INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1168;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1168;
                    break ; 
                    } 
                
                goto case 7 ;
                case 7 : 
                
                    { 
                    __context__.SourceCodeLine = 1169;
                    G_TWPARAMETER . OUT7INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1169;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1169;
                    break ; 
                    } 
                
                goto case 8 ;
                case 8 : 
                
                    { 
                    __context__.SourceCodeLine = 1170;
                    G_TWPARAMETER . OUT8INIT [ 7] = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1170;
                    FB_OUTXMARGINBOTTOM [ TVNUMBER]  .Value = (ushort) ( OUTXMARGINBOTTOM[ TVNUMBER ] .UshortValue ) ; 
                    __context__.SourceCodeLine = 1170;
                    break ; 
                    } 
                
                goto default;
                default : 
                
                    {
                    __context__.SourceCodeLine = 1171;
                    break ; 
                    }
                break;
                
                } 
                
            
            } 
        
        else 
            { 
            __context__.SourceCodeLine = 1175;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                { 
                __context__.SourceCodeLine = 1177;
                Print( "OutxMarginBottom is out of range,the valid range is 0~100!\r\n") ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object RX_BUFFER_OnChange_30 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort INDEX = 0;
        
        CrestronString STR;
        STR  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
        
        
        __context__.SourceCodeLine = 1194;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
            {
            __context__.SourceCodeLine = 1194;
            Print( "[RXString]Receive Source String = {0}\r\n", RX_BUFFER ) ; 
            }
        
        __context__.SourceCodeLine = 1195;
        INDEX = (ushort) ( Functions.Find( "\u000D" , RX_BUFFER ) ) ; 
        __context__.SourceCodeLine = 1196;
        while ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX > 0 ))  ) ) 
            { 
            __context__.SourceCodeLine = 1199;
            STR  .UpdateValue ( Functions.Remove ( INDEX, RX_BUFFER )  ) ; 
            __context__.SourceCodeLine = 1200;
            INDEX = (ushort) ( Functions.Find( "\u000D" , RX_BUFFER ) ) ; 
            __context__.SourceCodeLine = 1201;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (DEBUGMODE  .Value == 1))  ) ) 
                {
                __context__.SourceCodeLine = 1201;
                Print( "[RXString]Receive Cut String = {0}\r\n", STR ) ; 
                }
            
            __context__.SourceCodeLine = 1202;
            ANALYSISDATAFROMDEVICE (  __context__ , STR) ; 
            __context__.SourceCodeLine = 1196;
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

public override object FunctionMain (  object __obj__ ) 
    { 
    ushort J = 0;
    
    try
    {
        SplusExecutionContext __context__ = SplusFunctionMainStartCode();
        
        __context__.SourceCodeLine = 1219;
        ushort __FN_FORSTART_VAL__1 = (ushort) ( 0 ) ;
        ushort __FN_FOREND_VAL__1 = (ushort)7; 
        int __FN_FORSTEP_VAL__1 = (int)1; 
        for ( J  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (J  >= __FN_FORSTART_VAL__1) && (J  <= __FN_FOREND_VAL__1) ) : ( (J  <= __FN_FORSTART_VAL__1) && (J  >= __FN_FOREND_VAL__1) ) ; J  += (ushort)__FN_FORSTEP_VAL__1) 
            { 
            __context__.SourceCodeLine = 1221;
            G_TWPARAMETER . TWINPUTPORT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1222;
            G_TWPARAMETER . OUT1INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1223;
            G_TWPARAMETER . OUT2INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1224;
            G_TWPARAMETER . OUT3INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1225;
            G_TWPARAMETER . OUT4INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1226;
            G_TWPARAMETER . OUT5INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1227;
            G_TWPARAMETER . OUT6INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1228;
            G_TWPARAMETER . OUT7INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1229;
            G_TWPARAMETER . OUT8INIT [ J] = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 1219;
            } 
        
        __context__.SourceCodeLine = 1233;
        G_SIGNALTYPE [ 0 ]  .UpdateValue ( "NONE"  ) ; 
        __context__.SourceCodeLine = 1234;
        G_SIGNALTYPE [ 1 ]  .UpdateValue ( "UHD-HDMI"  ) ; 
        __context__.SourceCodeLine = 1235;
        G_SIGNALTYPE [ 2 ]  .UpdateValue ( "UHD-DVI"  ) ; 
        __context__.SourceCodeLine = 1236;
        G_SIGNALTYPE [ 3 ]  .UpdateValue ( "UHD-HDDMI-1.4"  ) ; 
        __context__.SourceCodeLine = 1237;
        G_SIGNALTYPE [ 4 ]  .UpdateValue ( "UHD-HDDMI-2.2"  ) ; 
        __context__.SourceCodeLine = 1239;
        G_INSIGNALFORMAT [ 0 ]  .UpdateValue ( "NO-SIGNAL"  ) ; 
        __context__.SourceCodeLine = 1240;
        G_INSIGNALFORMAT [ 1 ]  .UpdateValue ( "3840x2160p60"  ) ; 
        __context__.SourceCodeLine = 1241;
        G_INSIGNALFORMAT [ 2 ]  .UpdateValue ( "3840x2160p50"  ) ; 
        __context__.SourceCodeLine = 1242;
        G_INSIGNALFORMAT [ 3 ]  .UpdateValue ( "3840x2160p30"  ) ; 
        __context__.SourceCodeLine = 1243;
        G_INSIGNALFORMAT [ 4 ]  .UpdateValue ( "3840x2160p25"  ) ; 
        __context__.SourceCodeLine = 1244;
        G_INSIGNALFORMAT [ 5 ]  .UpdateValue ( "1920x1200p60"  ) ; 
        __context__.SourceCodeLine = 1245;
        G_INSIGNALFORMAT [ 6 ]  .UpdateValue ( "1920x1080p60"  ) ; 
        __context__.SourceCodeLine = 1246;
        G_INSIGNALFORMAT [ 7 ]  .UpdateValue ( "1920x1080p50"  ) ; 
        __context__.SourceCodeLine = 1247;
        G_INSIGNALFORMAT [ 8 ]  .UpdateValue ( "1600x1200p60"  ) ; 
        __context__.SourceCodeLine = 1248;
        G_INSIGNALFORMAT [ 9 ]  .UpdateValue ( "1400x1050p60"  ) ; 
        __context__.SourceCodeLine = 1249;
        G_INSIGNALFORMAT [ 10 ]  .UpdateValue ( "1366x768p60"  ) ; 
        __context__.SourceCodeLine = 1250;
        G_INSIGNALFORMAT [ 11 ]  .UpdateValue ( "1360x768p60"  ) ; 
        __context__.SourceCodeLine = 1251;
        G_INSIGNALFORMAT [ 12 ]  .UpdateValue ( "1280x1024p60"  ) ; 
        __context__.SourceCodeLine = 1252;
        G_INSIGNALFORMAT [ 13 ]  .UpdateValue ( "1280x768p60"  ) ; 
        __context__.SourceCodeLine = 1253;
        G_INSIGNALFORMAT [ 14 ]  .UpdateValue ( "1280x720p50"  ) ; 
        __context__.SourceCodeLine = 1254;
        G_INSIGNALFORMAT [ 15 ]  .UpdateValue ( "1280x720p60"  ) ; 
        __context__.SourceCodeLine = 1255;
        G_INSIGNALFORMAT [ 16 ]  .UpdateValue ( "1024x768p60"  ) ; 
        __context__.SourceCodeLine = 1258;
        G_OUTSIGNALFORMAT [ 0 ]  .UpdateValue ( "NO-SIGNAL"  ) ; 
        __context__.SourceCodeLine = 1259;
        G_OUTSIGNALFORMAT [ 1 ]  .UpdateValue ( "3840x2160p60"  ) ; 
        __context__.SourceCodeLine = 1260;
        G_OUTSIGNALFORMAT [ 2 ]  .UpdateValue ( "3840x2160p50"  ) ; 
        __context__.SourceCodeLine = 1261;
        G_OUTSIGNALFORMAT [ 3 ]  .UpdateValue ( "3840x2160p30"  ) ; 
        __context__.SourceCodeLine = 1262;
        G_OUTSIGNALFORMAT [ 4 ]  .UpdateValue ( "3840x2160p25"  ) ; 
        __context__.SourceCodeLine = 1263;
        G_OUTSIGNALFORMAT [ 5 ]  .UpdateValue ( "1920x1200p60"  ) ; 
        __context__.SourceCodeLine = 1264;
        G_OUTSIGNALFORMAT [ 6 ]  .UpdateValue ( "1920x1080p60"  ) ; 
        __context__.SourceCodeLine = 1265;
        G_OUTSIGNALFORMAT [ 7 ]  .UpdateValue ( "1920x1080p50"  ) ; 
        __context__.SourceCodeLine = 1266;
        G_OUTSIGNALFORMAT [ 8 ]  .UpdateValue ( "1600x1200p60"  ) ; 
        __context__.SourceCodeLine = 1267;
        G_OUTSIGNALFORMAT [ 9 ]  .UpdateValue ( "1400x1050p60"  ) ; 
        __context__.SourceCodeLine = 1268;
        G_OUTSIGNALFORMAT [ 10 ]  .UpdateValue ( "1366x768p60"  ) ; 
        __context__.SourceCodeLine = 1269;
        G_OUTSIGNALFORMAT [ 11 ]  .UpdateValue ( "1360x768p60"  ) ; 
        __context__.SourceCodeLine = 1270;
        G_OUTSIGNALFORMAT [ 12 ]  .UpdateValue ( "1280x1024p60"  ) ; 
        __context__.SourceCodeLine = 1271;
        G_OUTSIGNALFORMAT [ 13 ]  .UpdateValue ( "1280x768p60"  ) ; 
        __context__.SourceCodeLine = 1272;
        G_OUTSIGNALFORMAT [ 14 ]  .UpdateValue ( "1280x720p50"  ) ; 
        __context__.SourceCodeLine = 1273;
        G_OUTSIGNALFORMAT [ 15 ]  .UpdateValue ( "1280x720p60"  ) ; 
        __context__.SourceCodeLine = 1274;
        G_OUTSIGNALFORMAT [ 16 ]  .UpdateValue ( "1024x768p60"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler(); }
    return __obj__;
    }
    

public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    AUDIOOUTPORT  = new ushort[ 9 ];
    G_SIGNALTYPE  = new CrestronString[ 6 ];
    for( uint i = 0; i < 6; i++ )
        G_SIGNALTYPE [i] = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 50, this );
    G_INSIGNALFORMAT  = new CrestronString[ 17 ];
    for( uint i = 0; i < 17; i++ )
        G_INSIGNALFORMAT [i] = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 50, this );
    G_OUTSIGNALFORMAT  = new CrestronString[ 17 ];
    for( uint i = 0; i < 17; i++ )
        G_OUTSIGNALFORMAT [i] = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 50, this );
    G_TWPARAMETER  = new TVWALLPARAMTER( this, true );
    G_TWPARAMETER .PopulateCustomAttributeList( false );
    
    GETSYSTEMSTATUS = new Crestron.Logos.SplusObjects.DigitalInput( GETSYSTEMSTATUS__DigitalInput__, this );
    m_DigitalInputList.Add( GETSYSTEMSTATUS__DigitalInput__, GETSYSTEMSTATUS );
    
    GETINXFORMATSTATUS = new Crestron.Logos.SplusObjects.DigitalInput( GETINXFORMATSTATUS__DigitalInput__, this );
    m_DigitalInputList.Add( GETINXFORMATSTATUS__DigitalInput__, GETINXFORMATSTATUS );
    
    GETOUTXTYPESTATUS = new Crestron.Logos.SplusObjects.DigitalInput( GETOUTXTYPESTATUS__DigitalInput__, this );
    m_DigitalInputList.Add( GETOUTXTYPESTATUS__DigitalInput__, GETOUTXTYPESTATUS );
    
    GETOUTXFORMATSTATUS = new Crestron.Logos.SplusObjects.DigitalInput( GETOUTXFORMATSTATUS__DigitalInput__, this );
    m_DigitalInputList.Add( GETOUTXFORMATSTATUS__DigitalInput__, GETOUTXFORMATSTATUS );
    
    CANCELTVWALL = new Crestron.Logos.SplusObjects.DigitalInput( CANCELTVWALL__DigitalInput__, this );
    m_DigitalInputList.Add( CANCELTVWALL__DigitalInput__, CANCELTVWALL );
    
    SETMARGIN1X1 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN1X1__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN1X1__DigitalInput__, SETMARGIN1X1 );
    
    SETMARGIN1X2 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN1X2__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN1X2__DigitalInput__, SETMARGIN1X2 );
    
    SETMARGIN1X3 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN1X3__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN1X3__DigitalInput__, SETMARGIN1X3 );
    
    SETMARGIN1X4 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN1X4__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN1X4__DigitalInput__, SETMARGIN1X4 );
    
    SETMARGIN2X1 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN2X1__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN2X1__DigitalInput__, SETMARGIN2X1 );
    
    SETMARGIN3X1 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN3X1__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN3X1__DigitalInput__, SETMARGIN3X1 );
    
    SETMARGIN4X1 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN4X1__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN4X1__DigitalInput__, SETMARGIN4X1 );
    
    SETMARGIN2X2 = new Crestron.Logos.SplusObjects.DigitalInput( SETMARGIN2X2__DigitalInput__, this );
    m_DigitalInputList.Add( SETMARGIN2X2__DigitalInput__, SETMARGIN2X2 );
    
    AUDIOONLYOPEN = new Crestron.Logos.SplusObjects.DigitalInput( AUDIOONLYOPEN__DigitalInput__, this );
    m_DigitalInputList.Add( AUDIOONLYOPEN__DigitalInput__, AUDIOONLYOPEN );
    
    AUDIOONLYCLOSE = new Crestron.Logos.SplusObjects.DigitalInput( AUDIOONLYCLOSE__DigitalInput__, this );
    m_DigitalInputList.Add( AUDIOONLYCLOSE__DigitalInput__, AUDIOONLYCLOSE );
    
    AUDIOMODEMANUAL = new Crestron.Logos.SplusObjects.DigitalInput( AUDIOMODEMANUAL__DigitalInput__, this );
    m_DigitalInputList.Add( AUDIOMODEMANUAL__DigitalInput__, AUDIOMODEMANUAL );
    
    AUDIOMODEAUTO = new Crestron.Logos.SplusObjects.DigitalInput( AUDIOMODEAUTO__DigitalInput__, this );
    m_DigitalInputList.Add( AUDIOMODEAUTO__DigitalInput__, AUDIOMODEAUTO );
    
    SETINXAUDIOEMBEDDED = new InOutArray<DigitalInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        SETINXAUDIOEMBEDDED[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( SETINXAUDIOEMBEDDED__DigitalInput__ + i, SETINXAUDIOEMBEDDED__DigitalInput__, this );
        m_DigitalInputList.Add( SETINXAUDIOEMBEDDED__DigitalInput__ + i, SETINXAUDIOEMBEDDED[i+1] );
    }
    
    SETINXAUDIOLR = new InOutArray<DigitalInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        SETINXAUDIOLR[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( SETINXAUDIOLR__DigitalInput__ + i, SETINXAUDIOLR__DigitalInput__, this );
        m_DigitalInputList.Add( SETINXAUDIOLR__DigitalInput__ + i, SETINXAUDIOLR[i+1] );
    }
    
    PRESET_RECALL = new InOutArray<DigitalInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        PRESET_RECALL[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( PRESET_RECALL__DigitalInput__ + i, PRESET_RECALL__DigitalInput__, this );
        m_DigitalInputList.Add( PRESET_RECALL__DigitalInput__ + i, PRESET_RECALL[i+1] );
    }
    
    PRESET_SAVE = new InOutArray<DigitalInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        PRESET_SAVE[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( PRESET_SAVE__DigitalInput__ + i, PRESET_SAVE__DigitalInput__, this );
        m_DigitalInputList.Add( PRESET_SAVE__DigitalInput__ + i, PRESET_SAVE[i+1] );
    }
    
    FB_AUDIOONLYOPEN = new Crestron.Logos.SplusObjects.DigitalOutput( FB_AUDIOONLYOPEN__DigitalOutput__, this );
    m_DigitalOutputList.Add( FB_AUDIOONLYOPEN__DigitalOutput__, FB_AUDIOONLYOPEN );
    
    FB_AUDIOONLYCLOSE = new Crestron.Logos.SplusObjects.DigitalOutput( FB_AUDIOONLYCLOSE__DigitalOutput__, this );
    m_DigitalOutputList.Add( FB_AUDIOONLYCLOSE__DigitalOutput__, FB_AUDIOONLYCLOSE );
    
    FB_AUDIOMODEMANUAL = new Crestron.Logos.SplusObjects.DigitalOutput( FB_AUDIOMODEMANUAL__DigitalOutput__, this );
    m_DigitalOutputList.Add( FB_AUDIOMODEMANUAL__DigitalOutput__, FB_AUDIOMODEMANUAL );
    
    FB_AUDIOMODEAUTO = new Crestron.Logos.SplusObjects.DigitalOutput( FB_AUDIOMODEAUTO__DigitalOutput__, this );
    m_DigitalOutputList.Add( FB_AUDIOMODEAUTO__DigitalOutput__, FB_AUDIOMODEAUTO );
    
    FB_SETINXAUDIOEMBEDDED = new InOutArray<DigitalOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_SETINXAUDIOEMBEDDED[i+1] = new Crestron.Logos.SplusObjects.DigitalOutput( FB_SETINXAUDIOEMBEDDED__DigitalOutput__ + i, this );
        m_DigitalOutputList.Add( FB_SETINXAUDIOEMBEDDED__DigitalOutput__ + i, FB_SETINXAUDIOEMBEDDED[i+1] );
    }
    
    FB_SETINXAUDIOLR = new InOutArray<DigitalOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_SETINXAUDIOLR[i+1] = new Crestron.Logos.SplusObjects.DigitalOutput( FB_SETINXAUDIOLR__DigitalOutput__ + i, this );
        m_DigitalOutputList.Add( FB_SETINXAUDIOLR__DigitalOutput__ + i, FB_SETINXAUDIOLR[i+1] );
    }
    
    FB_PRESET = new InOutArray<DigitalOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_PRESET[i+1] = new Crestron.Logos.SplusObjects.DigitalOutput( FB_PRESET__DigitalOutput__ + i, this );
        m_DigitalOutputList.Add( FB_PRESET__DigitalOutput__ + i, FB_PRESET[i+1] );
    }
    
    SETTVWALL = new Crestron.Logos.SplusObjects.AnalogInput( SETTVWALL__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SETTVWALL__AnalogSerialInput__, SETTVWALL );
    
    SETVIDEOROUTING = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        SETVIDEOROUTING[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( SETVIDEOROUTING__AnalogSerialInput__ + i, SETVIDEOROUTING__AnalogSerialInput__, this );
        m_AnalogInputList.Add( SETVIDEOROUTING__AnalogSerialInput__ + i, SETVIDEOROUTING[i+1] );
    }
    
    SETAUDIOROUTING = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        SETAUDIOROUTING[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( SETAUDIOROUTING__AnalogSerialInput__ + i, SETAUDIOROUTING__AnalogSerialInput__, this );
        m_AnalogInputList.Add( SETAUDIOROUTING__AnalogSerialInput__ + i, SETAUDIOROUTING[i+1] );
    }
    
    SETOUTTYPE = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        SETOUTTYPE[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( SETOUTTYPE__AnalogSerialInput__ + i, SETOUTTYPE__AnalogSerialInput__, this );
        m_AnalogInputList.Add( SETOUTTYPE__AnalogSerialInput__ + i, SETOUTTYPE[i+1] );
    }
    
    SETOUTPUTFORMAT = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        SETOUTPUTFORMAT[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( SETOUTPUTFORMAT__AnalogSerialInput__ + i, SETOUTPUTFORMAT__AnalogSerialInput__, this );
        m_AnalogInputList.Add( SETOUTPUTFORMAT__AnalogSerialInput__ + i, SETOUTPUTFORMAT[i+1] );
    }
    
    OUTXMARGINLEFT = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        OUTXMARGINLEFT[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTXMARGINLEFT__AnalogSerialInput__ + i, OUTXMARGINLEFT__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTXMARGINLEFT__AnalogSerialInput__ + i, OUTXMARGINLEFT[i+1] );
    }
    
    OUTXMARGINRIGHT = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        OUTXMARGINRIGHT[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTXMARGINRIGHT__AnalogSerialInput__ + i, OUTXMARGINRIGHT__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTXMARGINRIGHT__AnalogSerialInput__ + i, OUTXMARGINRIGHT[i+1] );
    }
    
    OUTXMARGINTOP = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        OUTXMARGINTOP[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTXMARGINTOP__AnalogSerialInput__ + i, OUTXMARGINTOP__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTXMARGINTOP__AnalogSerialInput__ + i, OUTXMARGINTOP[i+1] );
    }
    
    OUTXMARGINBOTTOM = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        OUTXMARGINBOTTOM[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTXMARGINBOTTOM__AnalogSerialInput__ + i, OUTXMARGINBOTTOM__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTXMARGINBOTTOM__AnalogSerialInput__ + i, OUTXMARGINBOTTOM[i+1] );
    }
    
    FB_SETTVWALL = new Crestron.Logos.SplusObjects.AnalogOutput( FB_SETTVWALL__AnalogSerialOutput__, this );
    m_AnalogOutputList.Add( FB_SETTVWALL__AnalogSerialOutput__, FB_SETTVWALL );
    
    FB_OUTXFORMAT = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_OUTXFORMAT[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_OUTXFORMAT__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_OUTXFORMAT__AnalogSerialOutput__ + i, FB_OUTXFORMAT[i+1] );
    }
    
    FB_OUTXTYPE = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_OUTXTYPE[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_OUTXTYPE__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_OUTXTYPE__AnalogSerialOutput__ + i, FB_OUTXTYPE[i+1] );
    }
    
    FB_SETVIDEOROUTING = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_SETVIDEOROUTING[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_SETVIDEOROUTING__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_SETVIDEOROUTING__AnalogSerialOutput__ + i, FB_SETVIDEOROUTING[i+1] );
    }
    
    FB_SETAUDIOROUTING = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_SETAUDIOROUTING[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_SETAUDIOROUTING__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_SETAUDIOROUTING__AnalogSerialOutput__ + i, FB_SETAUDIOROUTING[i+1] );
    }
    
    FB_OUTXMARGINLEFT = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_OUTXMARGINLEFT[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_OUTXMARGINLEFT__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_OUTXMARGINLEFT__AnalogSerialOutput__ + i, FB_OUTXMARGINLEFT[i+1] );
    }
    
    FB_OUTXMARGINRIGHT = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_OUTXMARGINRIGHT[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_OUTXMARGINRIGHT__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_OUTXMARGINRIGHT__AnalogSerialOutput__ + i, FB_OUTXMARGINRIGHT[i+1] );
    }
    
    FB_OUTXMARGINTOP = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_OUTXMARGINTOP[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_OUTXMARGINTOP__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_OUTXMARGINTOP__AnalogSerialOutput__ + i, FB_OUTXMARGINTOP[i+1] );
    }
    
    FB_OUTXMARGINBOTTOM = new InOutArray<AnalogOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_OUTXMARGINBOTTOM[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( FB_OUTXMARGINBOTTOM__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( FB_OUTXMARGINBOTTOM__AnalogSerialOutput__ + i, FB_OUTXMARGINBOTTOM[i+1] );
    }
    
    RX_BUFFER = new Crestron.Logos.SplusObjects.StringInput( RX_BUFFER__AnalogSerialInput__, 4096, this );
    m_StringInputList.Add( RX_BUFFER__AnalogSerialInput__, RX_BUFFER );
    
    TX_BUFFER = new Crestron.Logos.SplusObjects.StringOutput( TX_BUFFER__AnalogSerialOutput__, this );
    m_StringOutputList.Add( TX_BUFFER__AnalogSerialOutput__, TX_BUFFER );
    
    FB_INXFORMAT = new InOutArray<StringOutput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        FB_INXFORMAT[i+1] = new Crestron.Logos.SplusObjects.StringOutput( FB_INXFORMAT__AnalogSerialOutput__ + i, this );
        m_StringOutputList.Add( FB_INXFORMAT__AnalogSerialOutput__ + i, FB_INXFORMAT[i+1] );
    }
    
    DEVICE_OUTPUT_NUM = new UShortParameter( DEVICE_OUTPUT_NUM__Parameter__, this );
    m_ParameterList.Add( DEVICE_OUTPUT_NUM__Parameter__, DEVICE_OUTPUT_NUM );
    
    DEVICE_INPUT_NUM = new UShortParameter( DEVICE_INPUT_NUM__Parameter__, this );
    m_ParameterList.Add( DEVICE_INPUT_NUM__Parameter__, DEVICE_INPUT_NUM );
    
    DEBUGMODE = new UShortParameter( DEBUGMODE__Parameter__, this );
    m_ParameterList.Add( DEBUGMODE__Parameter__, DEBUGMODE );
    
    
    SETMARGIN1X1.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN1X1_OnPush_0, false ) );
    SETMARGIN1X2.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN1X2_OnPush_1, false ) );
    SETMARGIN1X3.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN1X3_OnPush_2, false ) );
    SETMARGIN1X4.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN1X4_OnPush_3, false ) );
    SETMARGIN2X1.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN2X1_OnPush_4, false ) );
    SETMARGIN3X1.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN3X1_OnPush_5, false ) );
    SETMARGIN4X1.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN4X1_OnPush_6, false ) );
    SETMARGIN2X2.OnDigitalPush.Add( new InputChangeHandlerWrapper( SETMARGIN2X2_OnPush_7, false ) );
    GETSYSTEMSTATUS.OnDigitalPush.Add( new InputChangeHandlerWrapper( GETSYSTEMSTATUS_OnPush_8, true ) );
    AUDIOONLYOPEN.OnDigitalPush.Add( new InputChangeHandlerWrapper( AUDIOONLYOPEN_OnPush_9, true ) );
    AUDIOONLYCLOSE.OnDigitalPush.Add( new InputChangeHandlerWrapper( AUDIOONLYCLOSE_OnPush_10, true ) );
    AUDIOMODEMANUAL.OnDigitalPush.Add( new InputChangeHandlerWrapper( AUDIOMODEMANUAL_OnPush_11, true ) );
    AUDIOMODEAUTO.OnDigitalPush.Add( new InputChangeHandlerWrapper( AUDIOMODEAUTO_OnPush_12, true ) );
    for( uint i = 0; i < 8; i++ )
        PRESET_RECALL[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( PRESET_RECALL_OnPush_13, true ) );
        
    for( uint i = 0; i < 8; i++ )
        PRESET_SAVE[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( PRESET_SAVE_OnPush_14, true ) );
        
    GETINXFORMATSTATUS.OnDigitalPush.Add( new InputChangeHandlerWrapper( GETINXFORMATSTATUS_OnPush_15, true ) );
    GETOUTXFORMATSTATUS.OnDigitalPush.Add( new InputChangeHandlerWrapper( GETOUTXFORMATSTATUS_OnPush_16, true ) );
    GETOUTXTYPESTATUS.OnDigitalPush.Add( new InputChangeHandlerWrapper( GETOUTXTYPESTATUS_OnPush_17, true ) );
    for( uint i = 0; i < 8; i++ )
        SETINXAUDIOEMBEDDED[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( SETINXAUDIOEMBEDDED_OnPush_18, true ) );
        
    for( uint i = 0; i < 8; i++ )
        SETINXAUDIOLR[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( SETINXAUDIOLR_OnPush_19, true ) );
        
    CANCELTVWALL.OnDigitalPush.Add( new InputChangeHandlerWrapper( CANCELTVWALL_OnPush_20, true ) );
    for( uint i = 0; i < 8; i++ )
        SETVIDEOROUTING[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( SETVIDEOROUTING_OnChange_21, true ) );
        
    for( uint i = 0; i < 8; i++ )
        SETAUDIOROUTING[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( SETAUDIOROUTING_OnChange_22, true ) );
        
    for( uint i = 0; i < 8; i++ )
        SETOUTPUTFORMAT[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( SETOUTPUTFORMAT_OnChange_23, true ) );
        
    for( uint i = 0; i < 8; i++ )
        SETOUTTYPE[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( SETOUTTYPE_OnChange_24, true ) );
        
    SETTVWALL.OnAnalogChange.Add( new InputChangeHandlerWrapper( SETTVWALL_OnChange_25, true ) );
    for( uint i = 0; i < 8; i++ )
        OUTXMARGINLEFT[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTXMARGINLEFT_OnChange_26, true ) );
        
    for( uint i = 0; i < 8; i++ )
        OUTXMARGINRIGHT[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTXMARGINRIGHT_OnChange_27, true ) );
        
    for( uint i = 0; i < 8; i++ )
        OUTXMARGINTOP[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTXMARGINTOP_OnChange_28, true ) );
        
    for( uint i = 0; i < 8; i++ )
        OUTXMARGINBOTTOM[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTXMARGINBOTTOM_OnChange_29, true ) );
        
    RX_BUFFER.OnSerialChange.Add( new InputChangeHandlerWrapper( RX_BUFFER_OnChange_30, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_BZBGEAR_HDMI_MATRIX_SWITCHER_AND_VIDEOWALL_CONTROLLER ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint RX_BUFFER__AnalogSerialInput__ = 0;
const uint GETSYSTEMSTATUS__DigitalInput__ = 0;
const uint GETINXFORMATSTATUS__DigitalInput__ = 1;
const uint GETOUTXTYPESTATUS__DigitalInput__ = 2;
const uint GETOUTXFORMATSTATUS__DigitalInput__ = 3;
const uint CANCELTVWALL__DigitalInput__ = 4;
const uint SETMARGIN1X1__DigitalInput__ = 5;
const uint SETMARGIN1X2__DigitalInput__ = 6;
const uint SETMARGIN1X3__DigitalInput__ = 7;
const uint SETMARGIN1X4__DigitalInput__ = 8;
const uint SETMARGIN2X1__DigitalInput__ = 9;
const uint SETMARGIN3X1__DigitalInput__ = 10;
const uint SETMARGIN4X1__DigitalInput__ = 11;
const uint SETMARGIN2X2__DigitalInput__ = 12;
const uint AUDIOONLYOPEN__DigitalInput__ = 13;
const uint AUDIOONLYCLOSE__DigitalInput__ = 14;
const uint AUDIOMODEMANUAL__DigitalInput__ = 15;
const uint AUDIOMODEAUTO__DigitalInput__ = 16;
const uint SETINXAUDIOEMBEDDED__DigitalInput__ = 17;
const uint SETINXAUDIOLR__DigitalInput__ = 25;
const uint PRESET_RECALL__DigitalInput__ = 33;
const uint PRESET_SAVE__DigitalInput__ = 41;
const uint SETTVWALL__AnalogSerialInput__ = 1;
const uint SETVIDEOROUTING__AnalogSerialInput__ = 2;
const uint SETAUDIOROUTING__AnalogSerialInput__ = 10;
const uint SETOUTTYPE__AnalogSerialInput__ = 18;
const uint SETOUTPUTFORMAT__AnalogSerialInput__ = 26;
const uint OUTXMARGINLEFT__AnalogSerialInput__ = 34;
const uint OUTXMARGINRIGHT__AnalogSerialInput__ = 42;
const uint OUTXMARGINTOP__AnalogSerialInput__ = 50;
const uint OUTXMARGINBOTTOM__AnalogSerialInput__ = 58;
const uint TX_BUFFER__AnalogSerialOutput__ = 0;
const uint FB_AUDIOONLYOPEN__DigitalOutput__ = 0;
const uint FB_AUDIOONLYCLOSE__DigitalOutput__ = 1;
const uint FB_AUDIOMODEMANUAL__DigitalOutput__ = 2;
const uint FB_AUDIOMODEAUTO__DigitalOutput__ = 3;
const uint FB_SETINXAUDIOEMBEDDED__DigitalOutput__ = 4;
const uint FB_SETINXAUDIOLR__DigitalOutput__ = 12;
const uint FB_PRESET__DigitalOutput__ = 20;
const uint FB_SETTVWALL__AnalogSerialOutput__ = 1;
const uint FB_INXFORMAT__AnalogSerialOutput__ = 2;
const uint FB_OUTXFORMAT__AnalogSerialOutput__ = 10;
const uint FB_OUTXTYPE__AnalogSerialOutput__ = 18;
const uint FB_SETVIDEOROUTING__AnalogSerialOutput__ = 26;
const uint FB_SETAUDIOROUTING__AnalogSerialOutput__ = 34;
const uint FB_OUTXMARGINLEFT__AnalogSerialOutput__ = 42;
const uint FB_OUTXMARGINRIGHT__AnalogSerialOutput__ = 50;
const uint FB_OUTXMARGINTOP__AnalogSerialOutput__ = 58;
const uint FB_OUTXMARGINBOTTOM__AnalogSerialOutput__ = 66;
const uint DEVICE_OUTPUT_NUM__Parameter__ = 10;
const uint DEVICE_INPUT_NUM__Parameter__ = 11;
const uint DEBUGMODE__Parameter__ = 12;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}

[SplusStructAttribute(-1, true, false)]
public class TVWALLPARAMTER : SplusStructureBase
{

    [SplusStructAttribute(0, false, false)]
    public ushort  TVWALLMODE = 0;
    
    [SplusStructAttribute(1, false, false)]
    public ushort  [] TWINPUTPORT;
    
    [SplusStructAttribute(2, false, false)]
    public ushort  [] OUT1INIT;
    
    [SplusStructAttribute(3, false, false)]
    public ushort  [] OUT2INIT;
    
    [SplusStructAttribute(4, false, false)]
    public ushort  [] OUT3INIT;
    
    [SplusStructAttribute(5, false, false)]
    public ushort  [] OUT4INIT;
    
    [SplusStructAttribute(6, false, false)]
    public ushort  [] OUT5INIT;
    
    [SplusStructAttribute(7, false, false)]
    public ushort  [] OUT6INIT;
    
    [SplusStructAttribute(8, false, false)]
    public ushort  [] OUT7INIT;
    
    [SplusStructAttribute(9, false, false)]
    public ushort  [] OUT8INIT;
    
    
    public TVWALLPARAMTER( SplusObject __caller__, bool bIsStructureVolatile ) : base ( __caller__, bIsStructureVolatile )
    {
        TWINPUTPORT  = new ushort[ 9 ];
        OUT1INIT  = new ushort[ 10 ];
        OUT2INIT  = new ushort[ 10 ];
        OUT3INIT  = new ushort[ 10 ];
        OUT4INIT  = new ushort[ 10 ];
        OUT5INIT  = new ushort[ 10 ];
        OUT6INIT  = new ushort[ 10 ];
        OUT7INIT  = new ushort[ 10 ];
        OUT8INIT  = new ushort[ 10 ];
        
        
    }
    
}

}
